#include "quakedef.h"

PFNGLTEXIMAGE3DPROC glTexImage3D ;


int new_tele;
extern int	numgltextures;




BYTE *BuildTexture(void)
{
		int s, t;
#define WIDTH	4
#define HEIGHT	4
#define DEPTH	4
#define BYTES_PER_TEXEL	3
#define LAYER(r)	(WIDTH * HEIGHT * r * BYTES_PER_TEXEL)
#define TEXEL2(s, t)	(BYTES_PER_TEXEL * (s * WIDTH + t))			// 2->1 dimension mapping function
#define TEXEL3(s, t, r) (TEXEL2(s, t) + LAYER(r))	// 3->1 dimension mapping function

	// ask for enough memory for the texels and make sure we got it before proceeding
	BYTE *texels = (BYTE *)malloc(WIDTH * HEIGHT * DEPTH * BYTES_PER_TEXEL);
	if (texels == NULL)
		return NULL;


	// each of the following loops defines one layer of our 3d texture, there are 3 unsigned bytes (red, green, blue) for each texel so each iteration sets 3 bytes
	// the memory pointed to by texels is technically a single dimension (C++ won't allow more than one dimension to be of variable length), the 
	// work around is to use a mapping function like the one above that maps the 3 coordinates onto one dimension
	// layer 0 occupies the first (width * height * bytes per texel) bytes, followed by layer 1, etc...
	// define layer 0 as red
	for (s = 0; s < WIDTH; s++) {
		for (t = 0; t < HEIGHT; t++) {
			texels[TEXEL3(s, t, 0)] = 0x80;
			texels[TEXEL3(s, t, 0)+1] = 0x00;
			texels[TEXEL3(s, t, 0)+2] = 0x00;
		}
	}
	// define layer 1 as green
	for (s = 0; s < WIDTH; s++) {
		for (t = 0; t < HEIGHT; t++) {
			texels[TEXEL3(s, t, 1)] = 0x00;
			texels[TEXEL3(s, t, 1)+1] = 0x80;
			texels[TEXEL3(s, t, 1)+2] = 0x00;
		}
	}
	// define layer 2 as blue
	for (s = 0; s < WIDTH; s++) {
		for (t = 0; t < HEIGHT; t++) {
			texels[TEXEL3(s, t, 2)] = 0x00;
			texels[TEXEL3(s, t, 2)+1] = 0x00;
			texels[TEXEL3(s, t, 2)+2] = 0x80;
		}
	}

	// define layer 3 as grey
	for (s = 0; s < WIDTH; s++) {
		for (t = 0; t < HEIGHT; t++) {
			texels[TEXEL3(s, t, 3)] = 0x80;
			texels[TEXEL3(s, t, 3)+1] = 0x80;
			texels[TEXEL3(s, t, 3)+2] = 0x80;
		}
	}
	
	// tell OpenGL we're going to be setting up the texture name it gave us	
	glBindTexture(GL_TEXTURE_3D, new_tele);	
	// when this texture needs to be shrunk to fit on small polygons, use linear interpolation of the texels to determine the color
	glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	// when this texture needs to be magnified to fit on a big polygon, use linear interpolation of the texels to determine the color
	glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	// we want the texture to repeat over the S axis, so if we specify coordinates out of range we still get textured.
	glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	// same as above for T axis
	glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	// same as above for R axis
	glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_WRAP_R, GL_REPEAT);
	// this is a 3d texture, level 0 (max detail), GL should store it in RGB8 format, its WIDTHxHEIGHTxDEPTH in size, 
	// it doesnt have a border, we're giving it to GL in RGB format as a series of unsigned bytes, and texels is where the texel data is.
	glTexImage3D(GL_TEXTURE_3D, 0, GL_RGB8, WIDTH, HEIGHT, DEPTH, 0, GL_RGB, GL_UNSIGNED_BYTE, texels);

	return texels;
	
}


void Texture_Load (void){
	BYTE *tex;
	glTexImage3D = (PFNGLTEXIMAGE3DPROC) wglGetProcAddress("glTexImage3D");
	if (glTexImage3D == NULL)
		Com_Printf("WWWWWWWWWAAAAAAAAAEEEEEEEEEEEHhHHHH\n");
	new_tele= numgltextures++;
	tex = BuildTexture();
	
	//new_tele = GL_LoadTextureImage3D("textures/flat/tele.tga","tele",0,0,1);


};



