/*
	ghosts !
*/


#include "quakedef.h"
#include <time.h>
#include <string.h>
#include "glext.h"
#include <GL/glaux.h>


#define GL_FOG_COORDINATE_SOURCE_EXT	0x8450					// Value Taken From GLEXT.H
#define GL_FOG_COORDINATE_EXT		0x8451					// Value Taken From GLEXT.H


typedef void (APIENTRY * PFNGLFOGCOORDFEXTPROC) (GLfloat coord);

PFNGLFOGCOORDFEXTPROC glFogCoordfEXT = NULL;


float	gl_fogval;



void GL_Fog_Init(void)
{
	char Extension_Name[] = "EXT_fog_coord";
	
	// Allocate Memory For Our Extension String
	char* glextstring=(char *)malloc(strlen((char *)glGetString(GL_EXTENSIONS))+1);
	strcpy (glextstring,(char *)glGetString(GL_EXTENSIONS));		// Grab The Extension List, Store In glextstring
	Com_Printf("Loading Fog extension <--------------------\n");
	if (!strstr(glextstring,Extension_Name)){				// Check To See If The Extension Is Supported
		Com_Printf("Fog extension load failed !\n");
		return ;							// If Not, Return FALSE
	}

	free(glextstring);							// Free Allocated Memory

		


	// Setup And Enable glFogCoordEXT
	glFogCoordfEXT = (PFNGLFOGCOORDFEXTPROC) wglGetProcAddress("glFogCoordfEXT");

}


void GL_Fog_Enable(void){
	vec3_t	fogColor;
	fogColor[0] = 0;
	fogColor[1] = 1;
	fogColor[2] = 0;
	if (glFogCoordfEXT == NULL){
		Com_Printf("No glFogCoordfEXT\n");
		return;
	}
	glEnable(GL_FOG);							// Enable Fog
	glFogi(GL_FOG_MODE, GL_LINEAR);						// Fog Fade Is Linear
	glFogfv(GL_FOG_COLOR, fogColor);					// Set The Fog Color
	glFogf(GL_FOG_START,  0.0f);						// Set The Fog Start (Least Dense)
	glFogf(GL_FOG_END,    1.0f);						// Set The Fog End (Most Dense)
	glHint(GL_FOG_HINT, GL_NICEST);						// Per-Pixel Fog Calculation
	glFogi(GL_FOG_COORDINATE_SOURCE_EXT, GL_FOG_COORDINATE_EXT);		// Set Fog Based On Vertice

}

void GL_Fog_Disable(void){
		glDisable(GL_FOG);							// Enable Fog
}

void GL_Fog_Func(float f){
	glFogCoordfEXT(gl_fogval);

}

void FOG_Draw_Trail (void){
	return;
	//Com_Printf("Test\n");
	glDisable(GL_TEXTURE_2D);
	GL_Fog_Enable();
	//cl.frames[cl.validsequence & UPDATE_MASK].playerstate[cl.playernum].origin
	glBegin(GL_QUADS);
	glFogCoordfEXT(1.0);
	glVertex3f(100,100,100);
	glFogCoordfEXT(1.0);
	glVertex3f(100,100,150);
	glFogCoordfEXT(0.1);
	glVertex3f(100,150,150);
	glFogCoordfEXT(0.1);
	glVertex3f(150,100,100);
	GL_Fog_Disable();
	glEnd();
	glFlush();
	glEnable(GL_TEXTURE_2D);
}
