// Loads and does all the framebuffer stuff
#include "quakedef.h"

//#include <GL/glaux.h>
#include "gl_framebuffer.h"
#include "shaders.h"



fb_s	main_fb;
fb_s	hud_fb;
fb_s	fbs[4];

int use_fb , use_framebuffer;
int fb = 0;

cvar_t	framebuffer = {"framebuffer","0"};
cvar_t	r_multiview = {"r_multiview","0"};

cvar_t	fb_width = {"fb_width","0"};
cvar_t	fb_height = {"fb_height","0"};
cvar_t	fb_ratio_w = {"fb_ratio_w","0"};
cvar_t	fb_ratio_h = {"fb_ratio_h","0"};
cvar_t	fb_x = {"fb_x","0"};
cvar_t	fb_y = {"fb_y","0"};



// EXT_framebuffer_object - http://oss.sgi.com/projects/ogl-sample/registry/EXT/framebuffer_object.txt

extern PFNGLISRENDERBUFFEREXTPROC glIsRenderbufferEXT = NULL;
extern PFNGLBINDRENDERBUFFEREXTPROC glBindRenderbufferEXT = NULL;
extern PFNGLDELETERENDERBUFFERSEXTPROC glDeleteRenderbuffersEXT = NULL;
extern PFNGLGENRENDERBUFFERSEXTPROC glGenRenderbuffersEXT = NULL;
extern PFNGLRENDERBUFFERSTORAGEEXTPROC glRenderbufferStorageEXT = NULL;
extern PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC glGetRenderbufferParameterivEXT = NULL;
extern PFNGLISFRAMEBUFFEREXTPROC glIsFramebufferEXT = NULL;
extern PFNGLBINDFRAMEBUFFEREXTPROC glBindFramebufferEXT = NULL;
extern PFNGLDELETEFRAMEBUFFERSEXTPROC glDeleteFramebuffersEXT = NULL;
extern PFNGLGENFRAMEBUFFERSEXTPROC glGenFramebuffersEXT = NULL;
extern PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC glCheckFramebufferStatusEXT = NULL;
extern PFNGLFRAMEBUFFERTEXTURE1DEXTPROC glFramebufferTexture1DEXT = NULL;
extern PFNGLFRAMEBUFFERTEXTURE2DEXTPROC glFramebufferTexture2DEXT = NULL;
extern PFNGLFRAMEBUFFERTEXTURE3DEXTPROC glFramebufferTexture3DEXT = NULL;
extern PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC glFramebufferRenderbufferEXT = NULL;
extern PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC glGetFramebufferAttachmentParameterivEXT = NULL;
extern PFNGLGENERATEMIPMAPEXTPROC glGenerateMipmapEXT = NULL;
// GL_ARB_multitexture
extern PFNGLACTIVETEXTUREARBPROC       glActiveTextureEXT       = NULL;
extern PFNGLCLIENTACTIVETEXTUREARBPROC glClientActiveTextureEXT = NULL;
extern PFNGLMULTITEXCOORD2FARBPROC     glMultiTexCoord2fEXT     = NULL;


void Framebuffer_Init (void){
	char *ext = (char*)glGetString( GL_EXTENSIONS );
	int temp;

	if ((temp = COM_CheckParm("-framebuffer")) && temp + 1 < com_argc)
		use_framebuffer = Q_atoi(com_argv[temp+1]);

	if (!use_framebuffer)
		return;

	if( strstr( ext, "EXT_framebuffer_object" ) == NULL || !strstr(ext, "GL_ARB_multitexture")){
		Com_Printf("Framebuffer extension doesnt exist \n");
		use_fb = 0;
	}else{
		use_fb = 1;
		Com_Printf("Framebuffer extension do exist \n");
		glIsRenderbufferEXT = (PFNGLISRENDERBUFFEREXTPROC)wglGetProcAddress("glIsRenderbufferEXT");
		glBindRenderbufferEXT = (PFNGLBINDRENDERBUFFEREXTPROC)wglGetProcAddress("glBindRenderbufferEXT");
		glDeleteRenderbuffersEXT = (PFNGLDELETERENDERBUFFERSEXTPROC)wglGetProcAddress("glDeleteRenderbuffersEXT");
		glGenRenderbuffersEXT = (PFNGLGENRENDERBUFFERSEXTPROC)wglGetProcAddress("glGenRenderbuffersEXT");
		glRenderbufferStorageEXT = (PFNGLRENDERBUFFERSTORAGEEXTPROC)wglGetProcAddress("glRenderbufferStorageEXT");
		glGetRenderbufferParameterivEXT = (PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC)wglGetProcAddress("glGetRenderbufferParameterivEXT");
		glIsFramebufferEXT = (PFNGLISFRAMEBUFFEREXTPROC)wglGetProcAddress("glIsFramebufferEXT");
		glBindFramebufferEXT = (PFNGLBINDFRAMEBUFFEREXTPROC)wglGetProcAddress("glBindFramebufferEXT");
		glDeleteFramebuffersEXT = (PFNGLDELETEFRAMEBUFFERSEXTPROC)wglGetProcAddress("glDeleteFramebuffersEXT");
		glGenFramebuffersEXT = (PFNGLGENFRAMEBUFFERSEXTPROC)wglGetProcAddress("glGenFramebuffersEXT");
		glCheckFramebufferStatusEXT = (PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC)wglGetProcAddress("glCheckFramebufferStatusEXT");
		glFramebufferTexture1DEXT = (PFNGLFRAMEBUFFERTEXTURE1DEXTPROC)wglGetProcAddress("glFramebufferTexture1DEXT");
		glFramebufferTexture2DEXT = (PFNGLFRAMEBUFFERTEXTURE2DEXTPROC)wglGetProcAddress("glFramebufferTexture2DEXT");
		glFramebufferTexture3DEXT = (PFNGLFRAMEBUFFERTEXTURE3DEXTPROC)wglGetProcAddress("glFramebufferTexture3DEXT");
		glFramebufferRenderbufferEXT = (PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC)wglGetProcAddress("glFramebufferRenderbufferEXT");
		glGetFramebufferAttachmentParameterivEXT = (PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC)wglGetProcAddress("glGetFramebufferAttachmentParameterivEXT");
		glGenerateMipmapEXT = (PFNGLGENERATEMIPMAPEXTPROC)wglGetProcAddress("glGenerateMipmapEXT");
		glActiveTextureEXT       = (PFNGLACTIVETEXTUREARBPROC)      wglGetProcAddress("glActiveTextureARB");
		glClientActiveTextureEXT = (PFNGLCLIENTACTIVETEXTUREARBPROC)wglGetProcAddress("glClientActiveTextureARB");
		glMultiTexCoord2fEXT     = (PFNGLMULTITEXCOORD2FARBPROC)    wglGetProcAddress("glMultiTexCoord2fARB");
		if( !glIsRenderbufferEXT || !glBindRenderbufferEXT || !glDeleteRenderbuffersEXT || 
			!glGenRenderbuffersEXT || !glRenderbufferStorageEXT || !glGetRenderbufferParameterivEXT || 
			!glIsFramebufferEXT || !glBindFramebufferEXT || !glDeleteFramebuffersEXT || 
			!glGenFramebuffersEXT || !glCheckFramebufferStatusEXT || !glFramebufferTexture1DEXT || 
			!glFramebufferTexture2DEXT || !glFramebufferTexture3DEXT || !glFramebufferRenderbufferEXT||  
			!glGetFramebufferAttachmentParameterivEXT || !glGenerateMipmapEXT )
		{
			Com_Printf("Couldnt get the function adresses\n");
			use_fb = 0;
			return;
		}
		Cmd_AddCommand("framebuffer_load",Framebuffer_Main_Init);
		Cmd_AddCommand("framebuffer_edit",Framebuffer_Edit);
		Cmd_AddCommand("framebuffer_info",Framebuffer_Info);
		Cvar_Register(&framebuffer);
		Cvar_Register(&r_multiview);

		Cvar_Register(&fb_width);
		Cvar_Register(&fb_height);
		Cvar_Register(&fb_ratio_w);
		Cvar_Register(&fb_ratio_h);
		Cvar_Register(&fb_x);
		Cvar_Register(&fb_y);
		

	}

}

void Framebuffer_Info (void){


	Com_Printf("width: %i  height: %i\n",main_fb.width,main_fb.height);
	Com_Printf("real - width: %i  height: %i\n",main_fb.realwidth,main_fb.realheight);
	Com_Printf("%f %f\n",main_fb.ratio_w,main_fb.ratio_h);

}

void Framebuffer_Edit (void){
	extern RECT		WindowRect;
	int i;
	extern mvd_cams_t mvd_cams[4];

	switch(Cmd_Argc()){
		case 1: Com_Printf("%s fb option value\n",Cmd_Argv(0));break;
		case 2: Com_Printf("%s fb option value\n",Cmd_Argv(0));break;
		case 3: Com_Printf("%s fb option value\n",Cmd_Argv(0));break;
		case 4:	if (!strcmp("main",Cmd_Argv(1))){
					if (!strcmp("width",Cmd_Argv(2)))
						main_fb.realwidth = atoi(Cmd_Argv(3));
					if (!strcmp("height",Cmd_Argv(2)))
						main_fb.realheight = atoi(Cmd_Argv(3));
					if (!strcmp("x",Cmd_Argv(2)))
						main_fb.x = atoi(Cmd_Argv(3));
					if (!strcmp("y",Cmd_Argv(2)))
						main_fb.y = atoi(Cmd_Argv(3));
					main_fb.ratio_h = (float) main_fb.realheight / main_fb.height;
					main_fb.ratio_w = (float) main_fb.realwidth  / main_fb.width;
					break;
				}
				for (i=0;i<4;i++){
					if (i == atoi(Cmd_Argv(1))){
						if (!strcmp("width",Cmd_Argv(2)))
							mvd_cams[i].fbs.realwidth = atoi(Cmd_Argv(3));
						if (!strcmp("height",Cmd_Argv(2)))
							mvd_cams[i].fbs.realheight = atoi(Cmd_Argv(3));
						if (!strcmp("x",Cmd_Argv(2)))
							mvd_cams[i].fbs.x = atoi(Cmd_Argv(3));
						if (!strcmp("y",Cmd_Argv(2)))
							mvd_cams[i].fbs.y = atoi(Cmd_Argv(3));
					}
					mvd_cams[i].fbs.ratio_h = (float) fbs[i].realheight / fbs[i].height;
					mvd_cams[i].fbs.ratio_w = (float) fbs[i].realwidth  / fbs[i].width;
					Com_Printf("worked\n");
					break;
				}
		default:	break;
	}
	//main_fb.ratio_h = (float) (WindowRect.bottom - WindowRect.top) / main_fb.height;
	//main_fb.ratio_w = (float) (WindowRect.right - WindowRect.left)/ main_fb.width;

}

void Framebuffer_Disable (fb_s *fbs){
	if (!framebuffer.value)
		return;
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
}

void Framebuffer_Enable (fb_s *fbs){
	if (!framebuffer.value)
		return;
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fbs->fb);
	//glBindTexture(GL_TEXTURE_2D, fbs->texture);
	//glGenerateMipmapEXT(GL_TEXTURE_2D);
}

#define Q_ROUND_POWER2(in, out) {						\
	_mathlib_temp_int1 = in;							\
	for (out = 1; out < _mathlib_temp_int1; out <<= 1)	\
	;												\
}

void Framebuffer_Create (fb_s *fbs){
	GLenum status;
	extern RECT		WindowRect;
	if (!use_fb)
		return;
	if (!fbs->texture){
		Q_ROUND_POWER2(WindowRect.right - WindowRect.left, fbs->width);
		Q_ROUND_POWER2(WindowRect.bottom - WindowRect.top, fbs->height);
		if (fbs->width < main_fb.height)
			fbs->width = main_fb.height;
		else
			main_fb.height = main_fb.width;
		Com_Printf("%i %i\n",fbs->height,fbs->width);
		fbs->texture = texture_extension_number++;
		fbs->depthtex = texture_extension_number++;
		fbs->realwidth = (int )(WindowRect.right - WindowRect.left);
		fbs->realheight = (int )(WindowRect.bottom - WindowRect.top);
		fbs->ratio_h = (float) fbs->realheight / fbs->height;
		fbs->ratio_w = (float) fbs->realwidth  / fbs->width;
		fbs->x = 0;
		fbs->y = 0;
		Com_Printf("%i %i\n",fbs->height,fbs->width);
		Com_Printf("%i %i\n",fbs->realheight,fbs->realwidth);
	}

	// generate framebuffer
	glGenFramebuffersEXT(1,&fbs->fb);
	//glGenTextures(1,&fbs->texture);
	//generate depthbuffer
	glGenRenderbuffersEXT(1, &fbs->db);

	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fbs->fb);
	// initializing the texture
	glBindTexture(GL_TEXTURE_2D, fbs->texture);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA16, fbs->width, fbs->height, 0,
							GL_RGBA, GL_FLOAT, NULL);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
		//glTexParameterf(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE, GL_ALPHA);
		//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE, GL_NONE);
		//glTexParameterf(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE, GL_RED);

	glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,
							GL_COLOR_ATTACHMENT0_EXT,
							GL_TEXTURE_2D, fbs->texture, 0);
	
	// initializing the depthbuffer
	glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, fbs->db);
	glBindTexture(GL_TEXTURE_2D, fbs->depthtex);
	//remove 
	//glBindTexture(GL_TEXTURE_2D, fbs->texture);
	//glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB8, fbs->width, fbs->height, 0,
	//						GL_RGB, GL_FLOAT, NULL);


	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT24, fbs->width, fbs->height, 0,
							GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, NULL);


		


		glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT,
			GL_DEPTH_COMPONENT24 , fbs->width, fbs->height);
		glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT,
										GL_DEPTH_ATTACHMENT_EXT,
										GL_RENDERBUFFER_EXT, fbs->db);
		glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,
						GL_DEPTH_ATTACHMENT_EXT,
						GL_TEXTURE_2D, fbs->depthtex, 0);


	status = glCheckFramebufferStatusEXT (GL_FRAMEBUFFER_EXT);
		switch (status) 
		{
		case GL_FRAMEBUFFER_COMPLETE_EXT:
			Com_Printf("FB configuration supported\n");
			break;
		case GL_FRAMEBUFFER_UNSUPPORTED_EXT:
			Com_Printf("FB configuration unsupported\n");
			return ;
		default:
			Com_Printf("Framebuffer Error\n");
		return ;
}
glBindFramebufferEXT (GL_FRAMEBUFFER_EXT, 0);
}


void Framebuffer_Main_Init (void){
	if (!use_fb)
		return;
	if (main_fb.texture != 0)
		return;


	Framebuffer_Create(&main_fb);

	Framebuffer_Create(&hud_fb);

	
}

void PS_Rotate_Vector (vec3_t dst,vec3_t org,float degree_x, float degree_y);
void mvd_vectoangles(vec3_t vec, vec3_t ang);

void Framebuffer_Draw_3D (fb_s *fbs,float rx, float ry, float rz, float size, float ox, float oy, float oz){
	GLubyte pixel[4];
	GLint viewport[4];
	vec3_t	testvec,forward,right,up;

	int		ow = 0;

	if (!framebuffer.value)
		return;

	glEnable(GL_TEXTURE_2D);
	GL_Bind(fbs->texture);

	if (ow)
		glPushMatrix();

	if (!ow){
	AngleVectors (r_refdef.viewangles,forward, right, up);
	VectorScale(forward,oz,forward);
	VectorScale(right,ox,right);
	VectorScale(up,oy,up);
	//VectorAdd(testvec,up,testvec);
	
	VectorAdd(testvec,right,testvec);

	VectorAdd(r_refdef.vieworg,forward,testvec);
		}

	if (ow){
		VectorSet(testvec,ox,oy,oz);

		}
	glDisable(GL_TEXTURE_2D);
	glBegin(GL_POINTS);
	glVertex3fv(testvec);
	glEnd();
	glEnable(GL_TEXTURE_2D);

	/*
	testvec[0] = ox;//r_refdef.vieworg[0] + ox;
	testvec[1] = oy;//r_refdef.vieworg[1] + oy;
	testvec[2] = oz;//r_refdef.vieworg[2] + oz;
		*/
	//PS_Rotate_Vector(testvec,testvec,r_refdef.vieworg[0],r_refdef.vieworg[1]);

	//glTranslatef(r_refdef.vieworg[0]+ ox , r_refdef.vieworg[1] + oy, r_refdef.vieworg[2] + oz);
	glTranslatef(testvec[0],testvec[1],testvec[2]);

	if (!ow){
	VectorScale(forward,-1,forward);
	mvd_vectoangles(forward, testvec);
	
	if (testvec[1] >= 270 || testvec[1] <= 90){
					testvec[0] -= 90;
					if (testvec[0] < 0 )
						testvec[0] = -1 * testvec[0];
					else
						testvec[0] = 360 - testvec[0];
				}
	if (testvec[1] < 270 && testvec[1] > 90){
					testvec[0] -= 90;
					if (testvec[0] < 0 )
						testvec[0] = -1 * testvec[0];
					else 
						testvec[0] -= 270;
				}

		}
	

	if (ow){

	glRotatef (ry, 0, 0, 1);
	glRotatef (rx, 0, 1, 0);
	glRotatef (rz, 1, 0, 0);
		}

	if (!ow){

	glRotatef (testvec[1], 0, 0, 1);
	glRotatef (testvec[0], 0, 1, 0);
	glRotatef (-testvec[2], 1, 0, 0);

	glRotatef (ry, 0, 0, 1);
	glRotatef (rx, 0, 1, 0);
	glRotatef (-rz+180, 1, 0, 0);

		}

	glScalef(size, size, size);

	glBegin (GL_QUADS);

	glTexCoord2f (fbs->ratio_w,0);

	glVertex3f (size, -size, 0);
	
	glTexCoord2f (0,0);

	glVertex3f (size, size, 0);
	
	glTexCoord2f (0,fbs->ratio_h);

	glVertex3f (-size, size, 0);
	
	glTexCoord2f (fbs->ratio_w,fbs->ratio_h);

	glVertex3f (-size, -size, 0);

	glEnd();


	glRotatef(180,1,0,0);

	glBegin (GL_QUADS);

	glTexCoord2f (0,0);
	
	glVertex3f (size, -size, 0);
	
	glTexCoord2f (fbs->ratio_w,0);
	
	glVertex3f (size, size, 0);
	
	glTexCoord2f (fbs->ratio_w,fbs->ratio_h);
	
	glVertex3f (-size, size, 0);
	
	glTexCoord2f (0,fbs->ratio_h);

	glVertex3f (-size, -size, 0);
	glEnd();
	glPopMatrix();

	}

void Framebuffer_Draw (fb_s *fbs){
	extern cvar_t shader_fullscreen;
	double			cursor_loc[2];
	int shader = -1;
	GLubyte pixel[4];
	GLint viewport[4];
	if (!framebuffer.value)
		return;
	
	
	//GL_EnableMultitexture();
		GL_Bind(fbs->texture);


	
	shader = Shader_Lookup(shader_fullscreen.string);
	//if (shader != -1)
		//Shader_Enable(shader);


	glBegin (GL_QUADS);

	glTexCoord2f (0, 0);
	glVertex2f (fbs->x, fbs->y + fbs->realheight);

	// Upper right corner.
	glTexCoord2f (fbs->ratio_w, 0);
	glVertex2f (fbs->x + fbs->realwidth, fbs->y + fbs->realheight);

	// Bottom right corner.
	glTexCoord2f (fbs->ratio_w, fbs->ratio_h);
	glVertex2f (fbs->x + fbs->realwidth, fbs->y);

	// Bottom left corner.
	glTexCoord2f (0, fbs->ratio_h);
	glVertex2f (fbs->x, fbs->y);
	
	glEnd();

	Shader_Disable();
	return;

	glBindTexture(GL_TEXTURE_2D,fbs->depthtex);
	
	Shader_Disable();
	
	GL_DisableMultitexture();
	
	glBegin (GL_QUADS);

	glTexCoord2f (0, 0);
	glVertex2f (fbs->x/2, (fbs->y + fbs->realheight)/2);

	// Upper right corner.
	glTexCoord2f (fbs->ratio_w, 0);
	glVertex2f ((fbs->x + fbs->realwidth)/2, (fbs->y + fbs->realheight)/2);

	// Bottom right corner.
	glTexCoord2f (fbs->ratio_w, fbs->ratio_h);
	glVertex2f ((fbs->x + fbs->realwidth)/2, fbs->y/2);

	// Bottom left corner.
	glTexCoord2f (0, fbs->ratio_h);
	glVertex2f (fbs->x/2, fbs->y/2);
	
	glEnd();

	Shader_Disable();

	//glDisable(GL_BLEND);

}

/*





*/
