

// framebuffer struct
typedef struct fb_t {
	GLint fb;
	GLint db;
	int texture;
	int	depthtex;
	int width;
	int height;
	int realwidth;
	int realheight;
	float ratio_h;
	float ratio_w;
	int x;
	int y;
} fb_s;




// MVD Cams
typedef struct mvd_cams_s {
	vec3_t		origin;
	vec3_t		view;
	char			track[32];
	int			fps;
	double lasttime;
	int			recalc;
	int			currentframe;
	int			enable;
	fb_s		fbs;
} mvd_cams_t;

void Framebuffer_Main_Init(void);
void Framebuffer_Enable (fb_s *fbs);
void Framebuffer_Disable (fb_s *fbs);
void Framebuffer_Draw (fb_s *fbs);
void Framebuffer_Create (fb_s *fbs);
void Framebuffer_Edit(void);
void Framebuffer_Info (void);

void Framebuffer_Draw_3D (fb_s *fbs,float rx, float ry, float rz, float size, float ox, float oy, float oz);