/*

	A good menu system :>

*/


#include "quakedef.h"
void Draw_AlphaString (int x, int y, char *str, float alpha);
extern float hmx,hmy;
void Update_Num(void);

/* types 
	1 :	text
		- no subtypes
	2 :	button
		1 : Cbuf_AddText(name)
	3 :	slider
		1 : slide a cvar :D
		2 : slide a pointer
	4 :	textbox
		1 : set the cvar
		2 : set a pointer
	5 :	picture
	6 :	dropdownbox
	7 :	
*/

/* location
	
*/

/* align
	1 :	left/top
	2 :	right/bottom
	3 :	center
*/

typedef struct menu_ct_s {
	int		type;
	int		subtype;
	int		lx;
	int		ly;
	int		rx;
	int		ry;
	int		align;
	void	*function;
	char	*identifier;
	char	*name;
	int		drawn;
	char	*tooltip;
	char	*text;
	char	*color;
	int		width;
	cvar_t	*variable;
	float		limit[2];
	struct	menu_ct_s	*next;
	struct	menu_ct_s	*parent;
	mpic_t	*picture;
	int		**iptr;
	float	**fptr;
	double	**dptr;
} menu_ct_t;


typedef struct menu_s {
	int		show;
	struct	menu_s *next;
	struct	menu_ct_s *content;
	char	*name;
	char	*identifier;
	int		lx;
	int		ly;
	int		rx;
	int		ry;
	int		minimized;
	int		minx;
	int		miny;

} menu_t;

int		mscx	=	0;
int		mscy	=	0;
int		resizing	=	0;
int		moving		=	0;

qbool ON_Change_pp(cvar_t *var, char *string);

cvar_t	jogi_menu_system		=	{"jogi_menu_system","1"};
cvar_t	jogi_menu_system_debug	=	{"jogi_menu_system_debug","1"};
cvar_t	jogi_menu_system_border_alpha	=	{"jogi_menu_system_border_alpha","1"};
cvar_t	jogi_menu_system_background_alpha	=	{"jogi_menu_system_background_alpha","1"};
cvar_t	jogi_menu_system_red	=	{"jogi_menu_system_red","0"};
cvar_t	jogi_menu_system_green	=	{"jogi_menu_system_green","1"};
cvar_t	jogi_menu_system_blue	=	{"jogi_menu_system_blue","0"};

cvar_t	pp_size	=	{"pp_size","25"};
cvar_t	pp_time	=	{"pp_time","0.01",0,ON_Change_pp};

menu_t	*menu = NULL;
menu_t	*menu_active = NULL;

int		kdmb1;
int		kdmb2;

int		ssc = 0;
//int		selected_editbox =0 ;
menu_ct_t	*selected_editbox = NULL;
menu_ct_t	*selected_slider = NULL;
char	tmpstring[128];
float	editbox_lasttime;


qbool ON_Change_pp(cvar_t *var, char *string){
	if (atof(string)<= 0 ){
		Com_Printf("cant be <= 0\n");
		return false;
	}
	//Cvar_Set(&anal_selected_rocket,"0");
	Cvar_Set(var,string);
	return true;

}

int MS_Get_Key(key){
	int l;
	if (selected_editbox == NULL)
		return 0;
	switch (key) {
	case K_ESCAPE:
			memset(&tmpstring,0,sizeof(tmpstring));
			selected_editbox = NULL;
			ssc = 0;
			return 1;
	case K_ENTER:
			if (selected_editbox->subtype == 1)
				Cvar_Set(selected_editbox->variable,tmpstring);
			if (selected_editbox->subtype == 2){
				if (selected_editbox->iptr != NULL){
					**selected_editbox->iptr = atoi(tmpstring);
				}
				if (selected_editbox->fptr != NULL){
					**selected_editbox->fptr = atof(tmpstring);
				}
				if (selected_editbox->dptr != NULL){
					**selected_editbox->dptr = (double)atof(tmpstring);
				}
			}
			memset(&tmpstring,0,sizeof(tmpstring));
			selected_editbox = NULL;
			ssc = 0;
			return 1;
	case K_BACKSPACE:
			if (strlen(tmpstring))
					tmpstring[strlen(tmpstring)-1] = 0;
			return 1;
	default:
			if (key < 32 || key > 127)
				break;
			l = strlen(tmpstring);
			if (l < 128 && l< selected_editbox->width) {
				tmpstring[l+1] = 0;
				tmpstring[l] = key;
				return 1;
			}
			break;
	}
	return 0;
}

static void MS_Draw_Tooltip(int x, int y, char *string, float r, float g, float b,float alpha) 
{
	int len = strlen(string) * 8;

	// Make sure we're drawing within the screen.
	if (x + len > vid.width)
	{
		x -= len;
	}

	if (y + 9 > vid.height)
	{
		y -= 9;
	}

	Draw_AlphaFillRGB(x, y, len, 8, r, g, b,alpha);
	Draw_AlphaString(x, y, string,alpha);
}

void MS_Mouse(void){
	
	extern mpic_t	hud_cursor;
	menu_t	*mm;
	extern cvar_t	hud_cursor_alpha;
	extern cvar_t	hud_cursor_scale;

	int type = 0;
	int lx,ly,rx,ry;

	/*
	1- moving
	2- resize
	3- minimize
	4- close
	*/

	mm = menu_active;
	
	lx = mm->lx;
	ly = mm->ly;
	rx = mm->rx;
	ry = mm->ry;

	if (mm->minimized){
		rx = strlen(mm->name)*8+22 +lx;
		ry = ly + 22;
	}


		// we always draw the cursor
	if (hud_cursor.texnum){
		Draw_SAlphaPic(mscx,mscy,&hud_cursor,hud_cursor_alpha.value,hud_cursor_scale.value);
	}else{
		Draw_AlphaLineRGB(mscx,mscy,mscx+2,mscy+2,1,0,1,0,1);
	}
	
	// check if we are in the activemenu
	if ( mscx >= lx && mscx <= rx && mscy >= ly && mscy <= ry){
	
	}
	// check if we are in the moving area
	if (mscx >= lx && mscx <= rx - 18 && mscy >= ly && mscy <= ly + 10){
		MS_Draw_Tooltip(mscx,mscy,va("%s moving",mm->name,lx,ly,rx,ry),1,1,1,0.9);
		type = 1;

	}
	// check if we are in the resize area
	if (mscx >= rx - 10 && mscx <= rx && mscy >= ry - 10 && mscy <= ry){
		MS_Draw_Tooltip(mscx,mscy,va("%s resizing",mm->name),1,1,1,0.9);
		type = 2;
	}
	// minimize
	if (mscx >= rx - 17 && mscx <= rx - 9 && mscy >= ly + 1  && mscy <= ly + 10){
		MS_Draw_Tooltip(mscx,mscy,va("%s minimizing",mm->name),1,1,1,0.9);
		type = 3;
	}
	//Com_Printf("%f %f\n",hmx,hmy);
	if (mscx + hmx > 0 && mscx + hmx < vid.width)
		mscx	+=	hmx;
	if (mscy + hmy > 0 && mscy + hmy < vid.height)
		mscy	+=	hmy;
	


	

	if (keydown[K_MOUSE1] && 	!kdmb1)
			kdmb1 = 1;

	if (!keydown[K_MOUSE1] && 	kdmb1)
			kdmb1 = 0;

	if (!keydown[K_MOUSE1] && (resizing || moving)){
		if (resizing)
			resizing = 0;
		if (moving)
			moving = 0;
	}

	if (keydown[K_MOUSE1]  && (resizing || moving)){
		if (moving)
			type = 1;
		if (resizing)
			type = 2;
	}
	if (mm->rx < strlen(mm->name)*8)
		mm->rx = strlen(mm->name)*8 + 40;
	if (mm->ry < mm->ly + 20)
		mm->ry = mm->ly + 20;

	if (keydown[K_MOUSE1] && type){
		if (type == 1){
			if (mm->rx + hmx > vid.width || mm->ry + hmy > vid.height || mm->lx + hmx < 0 || mm->ly + hmy < 0)
				return;
			moving = 1;
			mm->lx += hmx;
			mm->rx += hmx;
			mm->ly += hmy;
			mm->ry += hmy;
			mscx = mm->lx + 2;
			mscy = mm->ly + 2;
		}
		if (type == 2){

			if (mm->rx + hmx > vid.width || mm->ry + hmy > vid.height || mm->ry +hmy< mm->ly + 20 || mm->rx +hmx <= mm->lx + strlen(mm->name)*8 + 22)
				return;
			mm->rx += hmx;
			mm->ry += hmy;
			resizing = 1;
			mscx = mm->rx - 5;
			mscy = mm->ry - 5;
		}
		if (type == 3)
			mm->minimized = !mm->minimized;
	}
}

void MS_Handle_Content_Slider(menu_ct_t *content){
	float	check;
	float	draw;
	float mp;

	// asign the check variable
	if (content->subtype == 1){
		check = content->variable->value;
	}else if (content->subtype == 2){
		if (content->iptr != NULL)
			check = **content->iptr;
		if (content->fptr != NULL)
			check = **content->fptr;
		if (content->dptr != NULL)
			check = **content->dptr;
	}
	if (hmx){
		if (keydown[K_CTRL])
			mp = 1;
		else
			mp = 0.1;

		if (content->subtype == 1){
			check += hmx *   mp;
		}
		
		if (content->subtype == 2 && content->fptr != NULL){
			check += hmx *   mp;
		}

		if (content->subtype == 2 && content->dptr != NULL){
			check += hmx *   mp;
		}

		if (content->subtype == 2 && content->iptr != NULL){
			if (hmx < 0)
				check -= 1;
			if (hmx > 0)
				check += 1;
		}
	}


	// check if we are in limits
	if (check < content->limit[0])
		check = content->limit[0];

	if (check > content->limit[1])
		check = content->limit[1];


	draw = (check - content->limit[0])/(content->limit[1] - content->limit[0]);

	if (keydown[K_MOUSE1]){

			if (content->subtype == 1){
				Cvar_Set(content->variable,va("%f",check));
			}
			
			if (content->subtype == 2 && content->fptr != NULL){
				**content->fptr = check;
			}

			if (content->subtype == 2 && content->dptr != NULL){
				**content->dptr = (double)check;
			}

			if (content->subtype == 2 && content->iptr != NULL){
				**content->iptr = (int) check;
			}

		// position the cursor correctly
		mscx = content->lx + (content->width-1)*8 * draw + 12;
		mscy = content->ly + 4;
	}
}

void MS_Handle_Content_Button(menu_ct_t *content){

	if (content->subtype == 1)
		Cbuf_AddText(content->name);

}

void MS_Handle_Content_Editbox(menu_ct_t *content){

	if (!ssc && keydown[K_MOUSE1]){
		selected_editbox = content;
		memset(tmpstring,0,(sizeof(char)* 128));
		if (content->subtype == 1)
			strcpy(tmpstring,content->variable->string);
		if (content->subtype == 2){
			if (content->iptr != NULL){
				strcpy(tmpstring,va("%i",**content->iptr));
			}
			if (content->fptr != NULL){
				strcpy(tmpstring,va("%f",**content->fptr));
			}
			if (content->dptr != NULL){
				strcpy(tmpstring,va("%f",**content->dptr));
			}
		}
		ssc=1;
	}

}

void MS_Handle_Content(menu_ct_t *content){

	if (content->type == 2)
		MS_Handle_Content_Button(content);
	if (content->type == 3)
		MS_Handle_Content_Slider(content);
	if (content->type == 4)
		MS_Handle_Content_Editbox(content);

	if (!kdmb1 && keydown[K_MOUSE1])
		S_LocalSound ("misc/menu1.wav");

}

void MS_Draw_Content_Text(menu_ct_t *content){
	int i ;
	char	buf[128];
	int	py=8;
	i = (content->rx - content->lx) / 8;
		if (content->subtype == 0){
			if (i > strlen(content->text)){
				Draw_String(content->lx,content->ly,content->text);
				content->rx = content->lx + strlen(content->text)*8;
			}else{
				strlcpy(buf,content->text,i);
				Draw_String(content->lx,content->ly,buf);
				content->rx = content->lx + strlen(buf)*8;
			}
		}else{
			if (i > strlen(content->text)){
				Draw_String(content->lx,content->ly,content->text);
				content->rx = content->lx + strlen(content->text)*8;
			}else{
				strlcpy(buf,content->text,i);
				Draw_String(content->lx,content->ly,buf);
				content->rx = content->lx + strlen(buf)*8;
			}
		}
		content->ry = content->ly + py;
}


void MS_Draw_Content_Button(menu_ct_t *content){
	int i;
	int py = 8;
	char	buf[128];

	i = (content->rx - content->lx) / 8;
	content->rx = content->lx + i * 8;
	if (i>1){
		if (i > strlen(content->text)){
			if ((content->color)){
				Draw_ColoredString(content->lx,content->ly,va("&c%s%s",content->color,content->text),0);
			}else{
				Draw_String(content->lx,content->ly,content->text);
			}
			content->rx = content->lx + strlen(content->text)*8;
		}else{
			strlcpy(buf,content->text,i);
			if ((content->color)){
				Draw_ColoredString(content->lx,content->ly,va("&c%s%s",content->color,buf),0);
			}else{
				Draw_String(content->lx,content->ly,buf);
			}
			content->rx = content->lx + strlen(buf)*8;
		}
	}
	content->ry = content->ly + py;
}

void MS_Draw_Content_Picture (menu_ct_t *content){
	int px,py;
		if (content->picture){
			if (content->lx + content->picture->width > content->rx - 1)
				px = content->rx - content->lx-1;
			else
				px = content->picture->width;

			if (content->ly + content->picture->height > content->ry - 1)
				py = content->ry - content->ly -1;
			else
				py = content->picture->height;

			content->rx = content->lx + px;
			content->ry = content->ly + py;
			content->rx = content->rx;
			content->ry = content->ry;

			//Draw_SAlphaSubPic(lx,ly,content->picture,content->picture->width,content->picture->height,px,py,1,1);
			Draw_SubPic(content->lx,content->ly,content->picture,0,0,px,py);
		}

}


void MS_Draw_Content_Slider (menu_ct_t	*content){
	float	check;
	float	draw;
	int		px;
	int		py = 8;
	int		i;
	
	px = content->width * 8 + 16;

	if (content->subtype == 1)
		check = content->variable->value;
	if (content->subtype == 2)
	{
		if (content->iptr != NULL)
			check = **content->iptr;
		if (content->fptr != NULL)
			check = **content->fptr;
		if (content->dptr != NULL)
			check = **content->dptr;
	}


	if (content->lx + px < content->rx)
	{
		Draw_Character(content->lx,content->ly,128);
		for (i=1;i<=content->width ;i++)
			Draw_Character(content->lx + i *8,content->ly,129);
		Draw_Character (content->lx +i *8, content->ly, 130);

		if (check < content->limit[0])
			draw = 0;
		if (check > content->limit[1])
			draw = 1;
		draw = (check - content->limit[0])/(content->limit[1] - content->limit[0]);
		Draw_Character (content->lx + (content->width-1)*8 * draw + 8, content->ly, 131);
		
		content->rx = content->lx + px;
		content->ry = content->ly + py;
	}
}

void MS_Draw_Content_Editbox (menu_ct_t *content){
	int		py = 8;
	int		i;
	char	buf[512];
	
	
	i = (content->rx - content->lx) / 8;

	// if we are the selected editbox draw a black background
	if (selected_editbox == content && i>strlen(tmpstring) && i>content->width)
		Draw_FadeBox(content->lx,content->ly,content->width * 8,8,0,0,0,1);

	if (content->subtype == 1)
		strcpy(buf,content->variable->string);

	if (content->subtype == 2)
	{
		if (content->iptr != NULL)
			strcpy(buf,va("%i",**content->iptr));
		if (content->fptr != NULL)
			strcpy(buf,va("%f",**content->fptr));
		if (content->dptr != NULL)
			strcpy(buf,va("%f",**content->dptr));
	}

	if (ssc){
		if (i>strlen(tmpstring) && selected_editbox == content){
			Draw_String(content->lx,content->ly,tmpstring);
		}else if  (i>strlen(buf) && selected_editbox != content){
			Draw_String(content->lx,content->ly,buf);
		}
	}else{
		if	(i>strlen(buf))
			Draw_String(content->lx,content->ly,buf);
	}


	content->ry = content->ly + py;
	content->rx = content->lx + 8 * content->width;

}


void MS_Draw_Content (menu_ct_t	*content){
	
	if (content->type == 1)
		MS_Draw_Content_Text(content);
	if (content->type == 2)
		MS_Draw_Content_Button(content);
	if (content->type == 3)
		MS_Draw_Content_Slider(content);
	if (content->type == 4)
		MS_Draw_Content_Editbox(content);
	if (content->type == 5)
		MS_Draw_Content_Picture(content);

}

void MS_Content(menu_t		*mm){
	int lx,ly,rx,ry,py;	// limits for the content
	char	buf[512];
	int		selected = 0;
	float	value= 0;

	menu_ct_t	*content;
	menu_ct_t	*selected_content = NULL;
	
	content = mm->content;
	
	while (content != NULL){
		memset(buf,0,sizeof(char)*512);
		selected = 0;
		// the first content of the menu is always top left
		if (content->parent == NULL){
			content->lx = mm->lx + 1;
			content->ly = mm->ly + 11;
			content->rx = mm->rx - 1;
			content->ry = mm->ry - 1;
		}else{
			// all other content relativ to the parent aligned to the right side
			if (content->align == 0 && content->parent){
				content->lx = content->parent->rx;
				content->ly = content->parent->ly;
				content->rx = mm->rx -1 ;
				content->ry = content->parent->ry ;
			}else if (content->align == 1 && content->parent){
				content->lx = content->parent->lx;
				content->ly = content->parent->ry;
				content->rx = mm->rx -1 ;
				content->ry = mm->ry -1 ;
			}
		}

		lx = content->lx;
		ly = content->ly;
		rx = content->rx;
		ry = content->ry;
		py = 8;

		
		if (ly+8 >= mm->ry && rx +8 >= mm->rx)
			break;

		MS_Draw_Content(content);

		if (mscx <= content->rx && mscx >= lx && mscy >= ly && mscy <= ly + py){
				selected = 1;
				selected_content = content;
		}

		
		mm->minx = content->rx;
		mm->miny = content->ly;
	
		content = content->next;
	}

	if (selected_content != NULL){
		if (selected_content->tooltip != NULL){
			if (selected_content->type == 1 && selected_content->subtype == 1){

			}else{
				MS_Draw_Tooltip(mscx,mscy,selected_content->tooltip,0.1,0.1,0.1,0.7);
			}
		}
		MS_Handle_Content(selected_content);
	}
	
}

void MS_Draw_ActiveMenu(menu_t	*mm){
	int lx,ly,rx,ry;
	lx = mm->lx;
	ly = mm->ly;
	rx = mm->rx;
	ry = mm->ry;

	if (mm->minimized){
		rx = strlen(mm->name)*8+22 + lx;
		ry = ly + 11;
	}
	// 
	Draw_FadeBox(lx, ly, rx - lx, ry - ly, 0.2, 0.2, 0.2, jogi_menu_system_background_alpha.value);
	// border
	Draw_AlphaRectangleRGB(lx, ly, rx - lx, ry - ly, jogi_menu_system_red.value, jogi_menu_system_green.value, jogi_menu_system_blue.value, 1, false, jogi_menu_system_border_alpha.value);
	// a line ;]
	Draw_AlphaLineRGB(lx, ly+10, rx, ly+10 , 1, jogi_menu_system_red.value, jogi_menu_system_green.value, jogi_menu_system_blue.value, jogi_menu_system_border_alpha.value);
	// menu name
	Draw_String(lx+2,ly+1,mm->name);
	// close
	Draw_FillRGB(rx - 9, ly + 1 ,8,8, 1,0,0);
	// minimize
	Draw_FillRGB(rx - 17, ly + 1 ,8,8, 0,0,1);


	if (mm->content && !mm->minimized){
		MS_Content(mm);
	}
		// resize
	if (!mm->minimized)
		Draw_FillRGB(rx - 9, ry - 9,8,8, 1,1,0);

}

void MS_Draw(void){
	if (!jogi_menu_system.value)
		return;
	Update_Num();
	MS_Draw_ActiveMenu(menu_active);
	MS_Mouse();
	
	

}



void Menu_Mainhook(void){

	

}

void MS_Add_Menu(int lx, int ly, int rx, int ry, char *name, char *identifier){
	menu_t	*lastmenu = NULL;
	menu_t	*my_menu;
	char	*mname;
	char	*midentifier;


	if (menu != NULL){
		lastmenu = menu;
		while (lastmenu){
			if (!strcmp(lastmenu->identifier,identifier)){
				Com_Printf("A menu with the identifier \"%s\" does already exist\n");
				return;
			}
			if (lastmenu->next == NULL)
				break;
			lastmenu = lastmenu->next;
		}
	}

	my_menu = malloc(sizeof(menu_t));
	
	my_menu->lx = lx;
	my_menu->ly = ly;
	my_menu->rx = rx;
	my_menu->ry = ry;

	mname = malloc((strlen(name)+1) * sizeof(char));
	memset(mname,0,strlen(name)+1);
	strncpy(mname,name,strlen(name));
	my_menu->name = mname;

	midentifier = malloc((strlen(identifier)+1) * sizeof(char));
	memset(midentifier,0,strlen(identifier)+1);
	strncpy(midentifier,identifier,strlen(identifier));
	my_menu->identifier = midentifier;

	my_menu->minimized = 0;
	my_menu->content = NULL;

	my_menu->next = NULL;



	if (menu == NULL)
		menu=my_menu;
	else if (lastmenu != NULL && menu != NULL)
		lastmenu->next = my_menu;



	
	

	


}

void MS_Add_Content(char *mid, char *pid, char *identifier, int type, int subtype, int align, char *text, char *tooltip, char *name, char *color, mpic_t *picture, cvar_t *variable, int width , float limmin, float limmax, char *ptype, void *vptr){
	menu_t		*my_menu;
	menu_ct_t	*my_content;
	menu_ct_t	*found_content = NULL;
	menu_ct_t	*my_parent = NULL;
	char *mchar;
	int		found	= 0;
	
	my_menu = menu;
	
	if (mid == NULL || identifier == NULL){
		Com_Printf("We need a parent identifier !\n");
		return;
	}

	while (my_menu){
		if (!strcmp(mid,my_menu->identifier)){
			found = 1;
			break;
		}
		if (my_menu->next == NULL)
			break;
		my_menu=my_menu->next;
	}
	if (!found)
	{
		Com_Printf("A menu with the identifier \"%s\" could not be found.\n",mid);
		return;
	}

	

	if (my_menu->content != NULL && pid != NULL){
		my_content = my_menu->content;
		while (my_content){
			if (!strcmp(my_content->identifier,pid)){
				my_parent = my_content;
			}
			if (my_content->next == NULL)
				break;
			my_content = my_content->next;
		}
	}
	if (my_parent == NULL && pid != NULL)
	{
		//Com_Printf("%s %s %s\n",mid,pid,text);
		//Com_Printf("Error !\n");
		return;
	}
	
	if (my_menu->content == NULL && pid == NULL && found_content == NULL){
		my_menu->content = malloc(sizeof(menu_ct_t));
		my_content = my_menu->content;
	}else if (my_content != NULL){
		my_content->next = malloc(sizeof(menu_ct_t));
		my_content = my_content->next;
	}

	my_content->parent = my_parent;

	my_content->lx = 0;
	my_content->ly = 0;
	my_content->rx = 0;
	my_content->ry = 0;
	my_content->type		= type;
	my_content->subtype		= subtype;
	my_content->align		= align;
	my_content->picture		= picture;
	my_content->variable	= variable;
	my_content->width		= width;
	my_content->limit[0]	= limmin;
	my_content->limit[1]	= limmax;
	//my_content->function	= function;

	mchar = malloc((strlen(identifier)+1) * sizeof(char));
	memset(mchar,0,strlen(identifier)+1);
	strncpy(mchar,identifier,strlen(identifier));
	my_content->identifier = mchar;

	if (name != NULL){
		mchar = malloc((strlen(name)+1) * sizeof(char));
		memset(mchar,0,strlen(name)+1);
		strncpy(mchar,name,strlen(name));
		my_content->name = mchar;
	}else{
		my_content->name = NULL;
	}

	if (text != NULL){
		mchar = malloc((strlen(text)+1) * sizeof(char));
		memset(mchar,0,strlen(text)+1);
		strncpy(mchar,text,strlen(text));
		my_content->text = mchar;
	}else{
		my_content->text = NULL;
	}

	if (tooltip != NULL){
		mchar = malloc((strlen(tooltip)+1) * sizeof(char));
		memset(mchar,0,strlen(tooltip)+1);
		strncpy(mchar,tooltip,strlen(tooltip));
		my_content->tooltip = mchar;
	}else{
		my_content->tooltip = NULL;
	}

	if (color != NULL){
		mchar = malloc((strlen(color)+1) * sizeof(char));
		memset(mchar,0,strlen(color)+1);
		strncpy(mchar,color,strlen(color));
		my_content->color = mchar;
	}else{
		my_content->color = NULL;
	}

	my_content->iptr = NULL;
	my_content->fptr = NULL;
	my_content->dptr = NULL;

	if (ptype == "i")
		my_content->iptr = (int **)vptr;
	
	if (ptype == "f")
		my_content->fptr = (float **)vptr;

	if (ptype == "d")
		my_content->dptr = (double **)vptr;
	
	my_content->next = NULL;
}



void MS_Activate_Menu(void){
	menu_t	*lastmenu = NULL;
	menu_t	*my_menu = NULL;
	
	if (menu != NULL){
		lastmenu = menu;
		while (lastmenu){
			if (!strcmp(lastmenu->identifier,Cmd_Argv(1))){
				//Com_Printf("A menu with the identifier \"%s\" does already exist\n");
				my_menu = lastmenu;
				break;
			}
			lastmenu = lastmenu->next;
		}
	}
	if (my_menu == NULL){
		Com_Printf("Menu does not exist\n");
		return;
	}
	menu_active = my_menu;
}
	
MS_Add_Content_Text(char *mid,char *pid,char *id,int align,char *text){
	
	MS_Add_Content(mid,pid,id,1,1,align,text,NULL,NULL,NULL,NULL,NULL,0,0,0,NULL,NULL);
	
}

/* types
	0 = normal type 1
	1 = 
	i
*/

MS_Add_Content_Button(char *mid, char *pid, char *id, int align,char type , void *vptr1, void *vptr2){


}

MS_Add_Content_Slider(char *mid, char *pid, char *id, int subtype, int align, char *ptype, void *vptr,float llim,float mlim){
	

	if (subtype == 1)
		MS_Add_Content(mid,pid,id,3,subtype,align,NULL,NULL,NULL,NULL,NULL,(cvar_t *)vptr,20,llim,mlim,NULL,NULL);
	if (subtype == 2){
		MS_Add_Content(mid,pid,id,3,subtype,align,NULL,NULL,NULL,NULL,NULL,NULL,20,llim,mlim,ptype,vptr);
		//Com_Printf("slider subtype 2\n");
	}
}

void MS_Console_Create_Menu(void){
	MS_Add_Menu(10,10,200,200,Cmd_Argv(1),Cmd_Argv(2));

	}

void MS_Console_Add_Content_Slider(void){
	cvar_t	*c = NULL;
	
	c = Cvar_FindVar(Cmd_Argv(4));

	if (!c)
		return;
	if (strlen(Cmd_Argv(2)))
		MS_Add_Content_Slider(Cmd_Argv(1),Cmd_Argv(2),Cmd_Argv(3),1,1,NULL,c,-100,100);
	else
		MS_Add_Content_Slider(Cmd_Argv(1),NULL,Cmd_Argv(3),1,1,NULL,c,-100,100);


	}
	

void Menu_Init(void){
	// some static testing
	extern mpic_t	hud_cursor;
	extern cvar_t	v_contrast;
	extern cvar_t	cl_rollspeed;
	int i =0;
	int j =0;
	cvar_t	*test;
	extern int *cam_num, *view_num;
	extern int *current_point, *cc_enable, *cc_show, *cc_type;
	extern int *current_view_point, *vv_enable, *vv_show, *vv_type;
	extern double *vv_startt, *vv_stopt, *cc_startt , *cc_stopt;
	extern float *cc_point_x,*cc_point_y,*cc_point_z;
	extern float *vv_point_x, *vv_point_y,*vv_point_z;
	extern double *testtime_pointer;
	
	extern int	*daswinkel_pointer;
	extern int	*dasanderewinkel_pointer;



	Update_Num();


	MS_Add_Menu(10,10,200,200,"Winkel Menu","wm_ident");
	MS_Add_Content_Slider("wm_ident",NULL,"ce_sl1",2,1,"i",&daswinkel_pointer,-360,360);
	MS_Add_Content_Slider("wm_ident","ce_sl1","ce_sl2",2,1,"i",&dasanderewinkel_pointer,-360,360);

	
	MS_Add_Menu(10,10,200,200,"Cam edit menu","ce_ident");
	menu_active = menu;
	// camera
	MS_Add_Content_Text("ce_ident",NULL,"ce_st1",1,"Camera :");

	MS_Add_Content_Text("ce_ident","ce_st1","ce_st10",1,"Show ");
	MS_Add_Content("ce_ident","ce_st10","ce_eb10",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"i",&cc_show);

	MS_Add_Content_Text("ce_ident","ce_st10","ce_st11",1,"Enable ");
	MS_Add_Content("ce_ident","ce_st11","ce_eb11",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"i",&cc_enable);


	MS_Add_Content_Text("ce_ident","ce_st11","ce_stt",1,"Splinetype ");
	MS_Add_Content("ce_ident","ce_stt","ce_ebt",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"i",&cc_type);

	MS_Add_Content_Text("ce_ident","ce_stt","ce_st2",1,"Camera Number ");
	MS_Add_Content_Slider("ce_ident","ce_st2","ce_sl1",2,1,"i",&cam_num,0,39);
	MS_Add_Content("ce_ident","ce_sl1","ce_eb1",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"i",&cam_num);



	MS_Add_Content_Text("ce_ident","ce_sl1","ce_st3",1,"Point number ");
	MS_Add_Content_Slider("ce_ident","ce_st3","ce_sl2",2,1,"i",&current_point,0,19);
	MS_Add_Content("ce_ident","ce_sl2","ce_eb2",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"i",&current_point);

	MS_Add_Content_Text("ce_ident","ce_sl2","ce_cst3",1,"Start Time : ");
	MS_Add_Content("ce_ident","ce_cst3","ce_csteb",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"d",&cc_startt);

	MS_Add_Content_Text("ce_ident","ce_cst3","ce_cst4",1,"Stop  Time : ");
	MS_Add_Content("ce_ident","ce_cst4","ce_csteb1",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"d",&cc_stopt);


	MS_Add_Content_Text("ce_ident","ce_cst4","ce_st4",1,"x ");
	MS_Add_Content_Slider("ce_ident","ce_st4","ce_sl3",2,0,"f",&cc_point_x,-10000,10000);
	MS_Add_Content("ce_ident","ce_sl3","ce_eb3",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"f",&cc_point_x);

	MS_Add_Content_Text("ce_ident","ce_st4","ce_st5",1,"y ");
	MS_Add_Content_Slider("ce_ident","ce_st5","ce_sl4",2,0,"f",&cc_point_y,-10000,10000);
	MS_Add_Content("ce_ident","ce_sl4","ce_eb4",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"f",&cc_point_y);

	MS_Add_Content_Text("ce_ident","ce_st5","ce_st6",1,"z ");
	MS_Add_Content_Slider("ce_ident","ce_st6","ce_sl5",2,0,"f",&cc_point_z,-10000,10000);
	MS_Add_Content("ce_ident","ce_sl5","ce_eb5",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"f",&cc_point_z);
	
	MS_Add_Content_Text("ce_ident","ce_st6","ce_es1",1,"");
	MS_Add_Content_Text("ce_ident","ce_es1","ce_es2",1,"");


	// view
	MS_Add_Content_Text("ce_ident","ce_es2","ce_vst1",1,"View :");

	MS_Add_Content_Text("ce_ident","ce_vst1","ce_vst10",1,"Show ");
	MS_Add_Content("ce_ident","ce_vst10","ce_veb10",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"i",&vv_show);

	MS_Add_Content_Text("ce_ident","ce_vst10","ce_vst11",1,"Enable ");
	MS_Add_Content("ce_ident","ce_vst11","ce_veb11",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"i",&vv_enable);


	MS_Add_Content_Text("ce_ident","ce_vst11","ce_vstt",1,"Splinetype ");
	MS_Add_Content("ce_ident","ce_vstt","ce_vebt",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"i",&vv_type);

	MS_Add_Content_Text("ce_ident","ce_vstt","ce_vst2",1,"View Number ");
	MS_Add_Content_Slider("ce_ident","ce_vst2","ce_vsl1",2,1,"i",&view_num,0,39);
	MS_Add_Content("ce_ident","ce_vsl1","ce_veb1",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"i",&view_num);



	MS_Add_Content_Text("ce_ident","ce_vsl1","ce_vst3",1,"Point number ");
	MS_Add_Content_Slider("ce_ident","ce_vst3","ce_vsl2",2,1,"i",&current_view_point,0,19);
	MS_Add_Content("ce_ident","ce_vsl2","ce_veb2",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"i",&current_view_point);

	MS_Add_Content_Text("ce_ident","ce_vsl2","ce_vcst3",1,"Start Time : ");
	MS_Add_Content("ce_ident","ce_vcst3","ce_vcsteb",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"d",&vv_startt);

	MS_Add_Content_Text("ce_ident","ce_vcst3","ce_vcst4",1,"Stop  Time : ");
	MS_Add_Content("ce_ident","ce_vcst4","ce_vcsteb1",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"d",&vv_stopt);


	MS_Add_Content_Text("ce_ident","ce_vcst4","ce_vst4",1,"x ");
	MS_Add_Content_Slider("ce_ident","ce_vst4","ce_vsl3",2,0,"f",&vv_point_x,-10000,10000);
	MS_Add_Content("ce_ident","ce_vsl3","ce_veb3",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"f",&vv_point_x);

	MS_Add_Content_Text("ce_ident","ce_vst4","ce_vst5",1,"y ");
	MS_Add_Content_Slider("ce_ident","ce_vst5","ce_vsl4",2,0,"f",&vv_point_y,-10000,10000);
	MS_Add_Content("ce_ident","ce_vsl4","ce_veb4",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"f",&vv_point_y);

	MS_Add_Content_Text("ce_ident","ce_vst5","ce_vst6",1,"z ");
	MS_Add_Content_Slider("ce_ident","ce_vst6","ce_vsl5",2,0,"f",&vv_point_z,-10000,10000);
	MS_Add_Content("ce_ident","ce_vsl5","ce_veb5",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"f",&vv_point_z);


	MS_Add_Content_Text("ce_ident","ce_vst6","ce_es3",1,"");
	MS_Add_Content_Text("ce_ident","ce_es3","ce_es4",1,"");
	MS_Add_Content_Text("ce_ident","ce_es4","ce_ttst",1,"testtime");
	MS_Add_Content_Slider("ce_ident","ce_ttst","ce_ttsl",2,0,"d",&testtime_pointer,0,10000);
	MS_Add_Content("ce_ident","ce_ttsl","ce_tteb",4,2,0,NULL,NULL,NULL,NULL,NULL,NULL,10,0,0,"d",&testtime_pointer);





	MS_Add_Menu(10,10,110,110,"Main Menu Appearance","mm_ident");
	MS_Add_Content("mm_ident",NULL,"mm_st1",1,1,0,"if u click -> ",NULL,NULL,NULL,NULL,NULL,0,0,0,NULL,NULL);
	MS_Add_Content("mm_ident","mm_st1","mm_bt1",2,1,0,">o<",NULL,"activate_menu cm_ident\n","ff0",NULL,NULL,0,0,0,NULL,NULL);
	MS_Add_Content("mm_ident","mm_bt1","mm_st2",1,1,0," <- the config menu should pop up",NULL,NULL,NULL,NULL,NULL,0,0,0,NULL,NULL);
	MS_Add_Content("mm_ident","mm_st1","mm_st3",1,1,1,"if u click -> ",NULL,NULL,NULL,NULL,NULL,0,0,0,NULL,NULL);
	MS_Add_Content("mm_ident","mm_st3","mm_bt2",2,1,0,">o<",NULL,"activate_menu mc_ident\n","ff0",NULL,NULL,0,0,0,NULL,NULL);
	MS_Add_Content("mm_ident","mm_bt2","mm_st3",1,1,0," <- the menu config should pop up",NULL,NULL,NULL,NULL,NULL,0,0,0,NULL,NULL);
	


	MS_Add_Menu(10,10,110,110,"Config Menu Appearance","mc_ident");

	MS_Add_Content("mc_ident",NULL,"cm_st1",1,1,0,va("%-15s ","red"),NULL,NULL,NULL,NULL,NULL,0,0,0,NULL,NULL);
	MS_Add_Content("mc_ident","cm_st1","cm_eb1",4,1,0,NULL,va("editbox for %s",jogi_menu_system_red.name),NULL,NULL,NULL,&jogi_menu_system_red,10,0,0,NULL,NULL);
	MS_Add_Content("mc_ident","cm_eb1","cm_sl1",3,1,0,NULL,va("slider for %s",jogi_menu_system_red.name),NULL,NULL,NULL,&jogi_menu_system_red,20,0,1,NULL,NULL);
	MS_Add_Content("mc_ident","cm_st1","cm_st2",1,1,1,va("%-15s ","green"),NULL,NULL,NULL,NULL,NULL,0,0,0,NULL,NULL);
	MS_Add_Content("mc_ident","cm_st2","cm_eb2",4,1,0,NULL,va("editbox for %s",jogi_menu_system_green.name),NULL,NULL,NULL,&jogi_menu_system_green,10,0,0,NULL,NULL);
	MS_Add_Content("mc_ident","cm_eb2","cm_sl2",3,1,0,NULL,va("slider for %s",jogi_menu_system_green.name),NULL,NULL,NULL,&jogi_menu_system_green,20,0,1,NULL,NULL);
	MS_Add_Content("mc_ident","cm_st2","cm_st3",1,1,1,va("%-15s ","blue"),NULL,NULL,NULL,NULL,NULL,0,0,0,NULL,NULL);
	MS_Add_Content("mc_ident","cm_st3","cm_eb3",4,1,0,NULL,va("editbox for %s",jogi_menu_system_blue.name),NULL,NULL,NULL,&jogi_menu_system_blue,10,0,0,NULL,NULL);
	MS_Add_Content("mc_ident","cm_eb3","cm_sl3",3,1,0,NULL,va("slider for %s",jogi_menu_system_blue.name),NULL,NULL,NULL,&jogi_menu_system_blue,20,0,1,NULL,NULL);
	MS_Add_Content("mc_ident","cm_st3","cm_st4",1,1,1,va("%-15s ","border alpha"),NULL,NULL,NULL,NULL,NULL,0,0,0,NULL,NULL);
	MS_Add_Content("mc_ident","cm_st4","cm_eb4",4,1,0,NULL,va("editbox for %s",jogi_menu_system_border_alpha.name),NULL,NULL,NULL,&jogi_menu_system_border_alpha,10,0,0,NULL,NULL);
	MS_Add_Content("mc_ident","cm_eb4","cm_sl4",3,1,0,NULL,va("slider for %s",jogi_menu_system_border_alpha.name),NULL,NULL,NULL,&jogi_menu_system_border_alpha,20,0,1,NULL,NULL);
	MS_Add_Content("mc_ident","cm_st4","cm_st5",1,1,1,va("%-15s ","background alpha"),NULL,NULL,NULL,NULL,NULL,0,0,0,NULL,NULL);
	MS_Add_Content("mc_ident","cm_st5","cm_eb5",4,1,0,NULL,va("editbox for %s",jogi_menu_system_border_alpha.name),NULL,NULL,NULL,&jogi_menu_system_background_alpha,10,0,0,NULL,NULL);
	MS_Add_Content("mc_ident","cm_eb5","cm_sl5",3,1,0,NULL,va("slider for %s",jogi_menu_system_border_alpha.name),NULL,NULL,NULL,&jogi_menu_system_background_alpha,20,0,1,NULL,NULL);
	MS_Add_Content("mc_ident","cm_st5","cm_bt1",2,1,1,"go back to mainmenu",NULL,"activate_menu mm_ident\n","ff0",NULL,NULL,0,0,0,NULL,NULL);

	MS_Add_Menu(110,110,300,300,"Config Menu","cm_ident");

	test = &cl_rollspeed;
	while (test){
		if (i ==0)
			MS_Add_Content("cm_ident",NULL,va("cm_st%i",i),1,1,0,va("%-30s",test->name),va("%s",test->name),test->name,NULL,NULL,NULL,0,0,0,NULL,NULL);
		else
			MS_Add_Content("cm_ident",va("cm_st%i",i-1),va("cm_st%i",i),1,1,1,va("%-30s",test->name),va("%s",test->name),test->name,NULL,NULL,NULL,0,0,0,NULL,NULL);

		
		MS_Add_Content("cm_ident",va("cm_st%i",i),va("cm_eb%i",i),4,1,0,NULL,va("editbox for %s",test->name),NULL,NULL,NULL,test,10,0,0,NULL,NULL);
		MS_Add_Content("cm_ident",va("cm_eb%i",i),va("cm_sl%i",i),3,1,0,NULL,va("slider for %s",test->name),NULL,NULL,NULL,test,20,-1000,1000,NULL,NULL);
		
		i++;
		test = test->next;
		if (i*8 > vid.height-20)
			break;
	}
	
	MS_Add_Menu(10,10,110,110,"Ponks Penis groesse","pp_ident");
	MS_Add_Content("pp_ident",NULL,"pp_eb1",4,1,0,NULL,va("editbox for %s",pp_size.name),NULL,NULL,NULL,&pp_size,10,0,0,NULL,NULL);
	MS_Add_Content("pp_ident","pp_eb1","pp_sl1",3,1,0,NULL,va("slider for %s",pp_size.name),NULL,NULL,NULL,&pp_size,20,0,3000,NULL,NULL);
	MS_Add_Content("pp_ident","pp_eb1","pp_eb2",4,1,1,NULL,va("editbox for %s",pp_time.name),NULL,NULL,NULL,&pp_time,10,0,0,NULL,NULL);
	MS_Add_Content("pp_ident","pp_eb2","pp_sl2",3,1,0,NULL,va("slider for %s",pp_time.name),NULL,NULL,NULL,&pp_time,20,0,3000,NULL,NULL);
	
	
	// Cvars
	Cvar_Register(&jogi_menu_system);
	Cvar_Register(&jogi_menu_system_debug);
	Cvar_Register(&jogi_menu_system_border_alpha);
	Cvar_Register(&jogi_menu_system_background_alpha);
	Cvar_Register(&jogi_menu_system_red);
	Cvar_Register(&jogi_menu_system_green);
	Cvar_Register(&jogi_menu_system_blue);
	Cmd_AddCommand("MS_activate_menu",MS_Activate_Menu);
	Cmd_AddCommand("MS_Console_Create_Menu",MS_Console_Create_Menu);
	Cmd_AddCommand("MS_Console_Add_Content_Slider",MS_Console_Add_Content_Slider);

	Cvar_Register(&pp_time);
	Cvar_Register(&pp_size);

	
}
