/*

*/

#include "quakedef.h"

int particles_count = 0;
void PS_Rotate_Vector (vec3_t dst,vec3_t org,float degree_x, float degree_y);
#define Cprintv(v,n) Com_Printf("%s - %f %f %f\n",n,v[0],v[1],v[2]);
#define Cprintt(a,c)			\
do {							\
	if (!c){					\
		Com_Printf("%s\n",a);	\
	}							\
	c = true;					\
} while (0);

#define rotate_gl(v)\
	glRotatef(v[0],1,0,0);\
	glRotatef(v[1],0,1,0);\
	glRotatef(v[2],0,0,1);\
	;

float r_1,r_2,r_3;

vec3_t	org,null;

#define lhrandom(MIN,MAX) ((rand() & 32767) * (((MAX)-(MIN)) * (1.0f / 32767.0f)) + (MIN))
#define V_Distance(a,b) sqrt(pow((a[0]- b[0]),2) + pow((a[1]- b[1]),2) + pow((a[2]- b[2]),2));
static float sint[7] = {0.000000, 0.781832, 0.974928, 0.433884, -0.433884, -0.974928, -0.781832};
static float cost[7] = {1.000000, 0.623490, -0.222521, -0.900969, -0.900969, -0.222521, 0.623490};

typedef enum { pt_bounce = 28 , pt_time = 15, pt_hit = 5, pt_origin = 8, pt_gravity = 6, pt_speed = 17, pt_direction = 1, pt_ival = 12, pt_color = 31, pt_sound = 9,pt_type = 2,pt_textures = 4, pt_size = 27, pt_light = 24, pt_rotation = 16, pt_python = 23};


typedef struct ps_g_point_s {
	vec3_t origin;
	float	gravity;
	float	distance;
} ps_g_point_t;

ps_g_point_t gravity_point[10];
void PS_Check_For_Quad(void);
void mvd_vectoangles(vec3_t vec, vec3_t ang);

vec3_t	geradeaus;
vec3_t	kommwerher,kuckmerhin;
int	daswinkel = 0;
int	*daswinkel_pointer = &daswinkel;

int	dasanderewinkel = 0;
int	*dasanderewinkel_pointer = &dasanderewinkel;


int unique_light_id = 10000;
int unique_id		= 1;

qbool	flipme ;



typedef struct p_light_s {
	int				unique_id;
	int				color;
	int				type;
	float			radius;
	float			time;
	qbool			custom;
	float			custom_color[3];
	
} p_light_t;



typedef struct p_color_s {
	int		blends_by;
	float	color1[4];
	float	color2[4];
	float	color1_s[4];
	float	color1_e[4];
	float	color2_s[4];
	float	color2_e[4];
} p_color_t;

typedef struct p_random_s {
	int		type;
	float	value1;
	float	value2;
	float	value3;
	float	value4;
	float	value5;
	float	value6;
	float	value7;
	float	value8;
} p_random_t;

typedef struct p_info_s {
	qbool	active;
	qbool	dies_by;
	int		blends_by;
	char	*spawns;
	float	value1;
	float	value2;
	float	value3;
	float	value4;
	float	value5;
	float	value6;
	float	value7;
	float	value8;
} p_info_t;


typedef struct ps_child_s {
	char			*identifier;					// name
	int				hash;							// like the cvars :>
	int				type;							// billboard etc etc
	float			starttime;						// time we spawned
	p_info_t		time;
	p_info_t		interval;
	p_info_t		bounce;
	p_light_t		light;
	p_info_t		speed;
	p_info_t		impact;
	p_color_t		color;
	p_random_t		random_direction;
	p_random_t		random_origin;
	p_random_t		rotation;
	p_random_t		g_point;

	//qbool			dies_by_impact;					// we do expire when whe hit something
	qbool			g_affected;						// are we affected by a gravity point
	//qbool			done;							// er ?
	float			g_modifier;						// gravity modifier
	char			*on_death_spawn;				// list of particles spawned when particle dies
	//char			*on_impact_spawn;				// list of particles spawned when particle impact

	vec3_t			origin;							// origin
	vec3_t			endorg;							//
	vec3_t			normal;							// the normal vector if we hit smth nice one for decals :D
	vec3_t			old_origin[9];
	vec3_t			direction;						// direction

	char			*python_module;
	char			*python_function;

	

	sfx_t			*sound;
	mpic_t			texture;
	qbool			sound_played;
	float			size;
	float			growth;
	unsigned int				unique_id;
	unsigned int				spawned_by;
	int				hit;
	int				bounced;
	//int				blend_over_time;				// 1 = start at 0 end at 255

} ps_child_t;

ps_child_t	*gravity_points[64];

ps_child_t	*python_particle = NULL;


typedef struct ps_plist_s {
	struct ps_plist_s	*next;
	struct ps_child_s	*particle;
} ps_plist_t;

ps_plist_t	*loaded_particles_list = NULL;
ps_plist_t	*draw_particles_list = NULL;

typedef struct ps_parent_s {
	float	time;
	char	*identifier;
	vec3_t	origin;
	vec3_t	direction;
	char	*plist;

} ps_parent_t;

typedef struct ps_parent_list_s {
	struct ps_parent_list_s	*next;
	struct ps_parent_s	*parent;
} ps_parent_list_t;

ps_parent_list_t	*ps_parent_list = NULL ;


cvar_t	PS_Use_Me	= {"ps_use_me","0"};
cvar_t	PS_Limit	= {"ps_limit","1000"};

int			gravity_points_count = 0;

void part_vectoangles(vec3_t	vec, vec3_t	ang){
	

	ang[1] = RAD2DEG(M_PI/2 - atan(vec[2]/sqrt(vec[0] * vec[0] + vec[1] * vec[1])));
	
	if (vec[2] < 0)
		ang[2] = RAD2DEG(2*M_PI - acos(vec[0]/sqrt(vec[0] * vec[0] + vec[1] * vec[1])));
	else
		ang[2] = RAD2DEG(acos(vec[0]/sqrt(vec[0] * vec[0] + vec[1] * vec[1])));
	ang[2] = 0;
}





void Particle_Python_Call(ps_child_t *p,char *module, char *function);

void PS_Test(void);

void PS_Draw_Particles(void){

	int j,k;
	ps_child_t	*p;
	vec3_t v, billboard[4],plane[4],forward,right,up,point;
	ps_plist_t *my_list;
	float test;

	my_list = draw_particles_list;

	
	
	VectorAdd(vup, vright, billboard[2]);
	VectorSubtract(vright, vup, billboard[3]);
	VectorNegate(billboard[2], billboard[0]);
	VectorNegate(billboard[3], billboard[1]);

	glDepthMask(GL_FALSE);
	glEnable(GL_BLEND);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	glShadeModel(GL_SMOOTH);


	glDisable(GL_TEXTURE_2D);

	glPointSize(5.0);
	glColor3f(1,1,0);
	while (my_list){
		
		p = my_list->particle;
		if (p->type == 0){
			glDisable(GL_TEXTURE_2D);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			glBegin(GL_POINTS);
			//Com_Printf("%s\n",my_list->particle->identifier);
			glColor4fv(p->color.color1);
			glVertex3fv(p->origin);
			glEnd();
		}
		
		if (p->type == 1){
			glDisable(GL_TEXTURE_2D);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE);
			glBegin(GL_TRIANGLE_FAN);
			glColor4fv(p->color.color1);
			glVertex3fv(p->origin);
			//glColor4ub(p->color[0] >> 1, p->color[1] >> 1, p->color[2] >> 1, 0);

			for (j = 7; j >= 0; j--) {
				for (k = 0; k < 3; k++)
					v[k] = p->origin[k] - p->direction[k] / 8 + vright[k] * cost[j % 7] * p->size + vup[k] * sint[j % 7] * p->size;
				glVertex3fv(v);
			}
			glEnd();
		}

		if (p->type == 2){
			glDisable(GL_TEXTURE_2D);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE);
			glBegin (GL_TRIANGLE_FAN);
			glColor4fv(p->color.color1);
			//Cprintv(p->color.color_start,"color start");
			//VectorScale(p->direction,p->speed.value/10,forward);
			VectorAdd(p->origin,p->direction,p->endorg);
			glVertex3fv(p->origin);
			glColor4fv(p->color.color2);
			
			for (j = 7; j >= 0; j--) {
				for (k = 0; k < 3; k++)
					v[k] = p->endorg[k] + vright[k] * cost[j % 7] * p->size + vup[k] * sint[j % 7] * p->size;
				glVertex3fv (v);
			}
			glEnd();
		}

		if (p->type == 3){
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_COLOR);
			if (!p->texture.texnum){
				Com_Printf("Test !\n");
				continue;
			}

			glEnable(GL_TEXTURE_2D);
			//VULT PARTICLES - I gather this speeds it up, but I haven't really checked
			GL_Bind(p->texture.texnum);
			
			glPushMatrix();
			glTranslatef(p->origin[0], p->origin[1], p->origin[2]);
			glScalef(p->size, p->size, p->size);
			if (p->rotation.value1)
				glRotatef(p->rotation.value1, vpn[0], vpn[1], vpn[2]);
			glColor4fv(p->color.color1);
			glBegin(GL_QUADS);
			glTexCoord2f(1.0f, 1.0f); glVertex3fv(billboard[0]);
			glTexCoord2f(0.0f, 1.0f); glVertex3fv(billboard[1]);
			glTexCoord2f(0.0f, 0.0f); glVertex3fv(billboard[2]);
			glTexCoord2f(1.0f, 0.0f); glVertex3fv(billboard[3]);
			glEnd();
			glPopMatrix();
	
	
		}


		if (p->type == 4){
				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_COLOR);
				glEnable(GL_TEXTURE_2D);
				GL_Bind(p->texture.texnum);
				glPushMatrix();
	

				VectorCopy(p->direction,p->endorg);

				mvd_vectoangles(p->endorg,p->endorg);

				glTranslatef(p->origin[0], p->origin[1], p->origin[2]);
				if (p->endorg[1] >= 270 || p->endorg[1] <= 90){
					p->endorg[0] -= 90;
					if (p->endorg[0] < 0 )
						p->endorg[0] = -1 * p->endorg[0];
					else
						p->endorg[0] = 360 - p->endorg[0];
				}
				if (p->endorg[1] < 270 && p->endorg[1] > 90){
					p->endorg[0] -= 90;
					if (p->endorg[0] < 0 )
						p->endorg[0] = -1 * p->endorg[0];
					else 
						p->endorg[0] -= 270;
				}

				
				glRotatef (p->endorg[1], 0, 0, 1);
				glRotatef (p->endorg[0], 0, 1, 0);
				glRotatef (p->endorg[2], 1, 0, 0);
				glScalef(p->size, p->size, p->size);
				
					


				glColor4fv(p->color.color1);
				glBegin (GL_QUADS);
				glTexCoord2f (0,0);
				glVertex3f (-p->size, -p->size, 0);
				glTexCoord2f (1,0);
				glVertex3f (p->size, -p->size, 0);
				glTexCoord2f (1,1);
				glVertex3f (p->size, p->size, 0);
				glTexCoord2f (0,1);
				glVertex3f (-p->size, p->size, 0);
				glEnd();

				glRotatef(180,1,0,0);
				glBegin (GL_QUADS);
				glTexCoord2f (0,0);
				glVertex3f (-p->size, -p->size, 0);
				glTexCoord2f (1,0);
				glVertex3f (p->size, -p->size, 0);
				glTexCoord2f (1,1);
				glVertex3f (p->size, p->size, 0);
				glTexCoord2f (0,1);
				glVertex3f (-p->size, p->size, 0);
				glEnd();

				glPopMatrix();
		}


		
	
		glFlush();
		if (my_list->next)
			my_list=my_list->next;
		else
			break;
	}
	
	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_TEXTURE_2D);
	/*
	glPointSize(5.0);
	glDisable(GL_TEXTURE_2D);
	glColor3f(0,0,1);
	glBegin(GL_POINTS);
	glVertex3fv(gravity_point[0].origin);
	glVertex3fv(gravity_point[1].origin);
	glVertex3fv(gravity_point[2].origin);
	glEnd();
	glBegin(GL_LINES);
	glVertex3fv(gravity_point[0].origin);
	glVertex3fv(gravity_point[1].origin);
	glEnd();
	glBegin(GL_LINES);
	glVertex3fv(gravity_point[0].origin);
	glVertex3fv(gravity_point[2].origin);
	glEnd();
	glFlush();
	glEnable(GL_TEXTURE_2D);
	PS_Test();
	*/

}

static qbool TraceLineN (vec3_t start, vec3_t end, vec3_t impact, vec3_t normal) {
	trace_t trace;

	memset (&trace, 0, sizeof(trace));
	trace.fraction = 1;
	if (PM_RecursiveHullCheck (cl.worldmodel->hulls, 0, 0, 1, start, end, &trace))
		return false;
	VectorCopy (trace.endpos, impact);
	if (normal)
		VectorCopy (trace.plane.normal, normal);

	return true;
}

#define TruePointContents(p) PM_HullPointContents(&cl.worldmodel->hulls[0], 0, p)


void CL_NewDlight_RGB (int key, vec3_t origin, float radius, float time, int type, int bubble, qbool color, float r, float g, float b);
void PS_Spawn_Particles_From_Particle(char *identifier,ps_child_t *parent);

void PS_Check_Particles(void){
	ps_plist_t *last;
	ps_plist_t *current;
	ps_plist_t *temp;
	ps_child_t *p;
	qbool dead,hit,test;
	char *p_id,*buf;
	vec3_t	oldorg,stop,normal,gp_accel,forward,right,up;
	int i;
	float bounce, grav,distance,v1,v2;


	flipme = !flipme;

	//if (flipme)
//		return;
	PS_Check_For_Quad();
	current = draw_particles_list;
	grav = movevars.gravity / 800.0;




	while (current && current->particle){
		dead = false;
		hit = false;
		test = true;
		p = current->particle;

		// time.modifer wich is (currenttime - starttime)/time.value
		p->time.value6 = (r_refdef2.time - p->starttime) / p->time.value1;



		// check if p is dead :D
		if (!p->sound_played){
			S_StartSound (cl.playernum+1, -1, p->sound, p->origin, 0.5, 1);
			//S_StaticSound_OneTime(,p->on_bounce_spawn,0.5,0.5);
			p->sound_played = true;
		}
		if (r_refdef2.time > (p->starttime + p->time.value1) && p->time.dies_by)
			dead = true;
		
		if (dead)
			Cprintt("i died from time\n",test);


		p->speed.value8 = VectorLength(p->direction);
		//Com_Printf("%f\n",p->speed.value8);

		if (p->speed.value8 < p->speed.value1 && p->speed.dies_by == 1)
			dead = true;

		if (dead)
			Cprintt("i died from speed\n",test);

		if (p->speed.value8 > p->speed.value1 && p->speed.dies_by == 2)
			dead = true;
		if (dead)
			Cprintt("i died from speed\n",test);

		if (p->bounce.dies_by && p->bounce.value1 < 0)
			dead = true;
		if (dead)
			Cprintt("i died from bouncelimit\n",test);


		if (p->rotation.type == 2){
			p->rotation.value8 = lhrandom(p->rotation.value1,p->rotation.value2);
		}
		if (p->rotation.type == 3){
			v1 = lhrandom(p->rotation.value1,p->rotation.value2);
			v2 = lhrandom(p->rotation.value3,p->rotation.value4);
			PS_Rotate_Vector(p->direction,p->direction,v1,v2);
			VectorScale(p->direction,p->speed.value8,p->direction);
		}
		if (p->rotation.type == 4){
			if (p->rotation.value5 != -1){
				v1 = lhrandom(p->rotation.value1,p->rotation.value2);
				v2 = lhrandom(p->rotation.value3,p->rotation.value4);
				p->rotation.value5 = -1;
				p->rotation.value6 = v1;
				p->rotation.value7 = v2;
			}
			PS_Rotate_Vector(p->direction,p->direction,p->rotation.value6,p->rotation.value7);
			VectorScale(p->direction,p->speed.value8,p->direction);
		}
		if (p->rotation.type ==5){
			mvd_vectoangles(p->direction,forward);
			AngleVectors(forward,NULL,right,NULL);
			
			VectorMA(p->direction,p->rotation.value1,right,p->direction);
			VectorNormalize(p->direction);
			VectorScale(p->direction,p->speed.value8,p->direction);
		}


		if (p->interval.value1 != 0 && (p->interval.value2 == 0 || (p->interval.value2 == 1 && p->interval.value3 > 0))){
			if (p->interval.value4  < r_refdef2.time){
				p->interval.value4 = r_refdef2.time + p->interval.value1;
				buf = Q_strdup(p->interval.spawns);
				p_id = strtok(buf, " ");
				p->interval.value3 -= 1;
				while ( p_id != NULL){
					PS_Spawn_Particles_From_Particle(p_id,p);
					p_id = strtok(NULL, " ");
				}
				Q_free(buf);
			}
		}

		if (p->growth)
			p->size += p->size * p->growth * cls.frametime;

		// we blend thats just transparency
		/*
		if (p->time.blends_by == 1){
			p->color.color[3] = ((r_refdef2.time -p->starttime)/p->time.dies_by);
		}
		if (p->time.blends_by == 2){
			p->color.color[3] = 1 - ((r_refdef2.time -p->starttime)/p->time.dies_by);
		}
		*/
		// this is color over time
		if (p->color.blends_by == 1){
			for (i=0;i<4;i++){
				p->color.color1[i] = p->color.color1_s[i] + (p->color.color1_e[i] - p->color.color1_s[i]) * p->time.value6;
				p->color.color2[i] = p->color.color2_s[i] + (p->color.color2_e[i] - p->color.color2_s[i]) * p->time.value6;
			}
		}


		// apply the modifier to the speed
		// apply acceleration
		if (p->random_direction.type != 4)
			VectorScale(p->direction, 1 + p->speed.value2 * cls.frametime, p->direction)
//			Com_Printf("speed %f\n",VectorLength(p->direction));
		// apply gravity
		if (p->random_direction.type != 4)
			p->direction[2] -= p->g_modifier * grav * cls.frametime;

		// gravity points
		if (p->g_affected){
			for (i=0;i<gravity_points_count;i++){
				if (p != gravity_points[i]){
					distance = V_Distance(p->origin,gravity_points[i]->origin)
					if (distance <= gravity_points[i]->g_point.value1){
						VectorSubtract(gravity_points[i]->origin, p->origin, gp_accel);
						VectorNormalize(gp_accel);
						VectorMA(p->direction,  (distance/gravity_points[i]->g_point.value2) * gravity_points[i]->g_point.value1, gp_accel, p->direction);
					}
				}
			}
		}


		// move it and check if we hit smth
		VectorCopy(p->origin, oldorg);
		if (p->random_direction.type != 4)
			VectorMA(p->origin, cls.frametime, p->direction, p->origin);
		if (-2 == TruePointContents (p->origin)) {
			if (TraceLineN(oldorg, p->origin, stop, normal)){
				VectorCopy(stop, p->origin);
				hit = true;
				p->hit = 1;
				//Com_Printf("%i\n",p->hit);
			}else{
				p->hit = 0;
			}
		}
		//Cprintv(p->origin,"origin");

		VectorCopy(oldorg,p->old_origin[0]);

		if (VectorLength(normal) && hit)
			VectorCopy(normal,p->normal);
	
		//if (hit)
		//	Cprintv(p->normal,"Normal");

		if (p->light.unique_id){
			CL_NewDlight_RGB(p->light.unique_id,p->origin, p->light.radius, p->light.time, p->light.type, 0,p->light.custom,p->light.custom_color[0],p->light.custom_color[1],p->light.custom_color[2]);

			}

		if (p->bounce.active && hit && VectorCompare(p->origin,oldorg))
			dead = true;
		if (dead)
			Cprintt("i died cuz i dont bounce\n",test);

		if (p->bounce.value2 && hit && !VectorCompare(p->origin,oldorg)){
			bounce = -p->bounce.value3 * DotProduct(p->direction, normal);
			VectorMA(p->direction, bounce, normal, p->direction);
			p->bounce.value1 -= 1;
			if (p->bounce.spawns != NULL){
				buf = Q_strdup(p->bounce.spawns);
				p_id = strtok(buf, " ");
				while ( p_id != NULL){
					PS_Spawn_Particles_From_Particle(p_id,p);
					p_id = strtok(NULL, " ");
				}
				Q_free(buf);
			}
		}

		if (p->impact.dies_by && hit){
			if (p->impact.spawns != NULL){
				//Com_Printf("Test\n");
				buf = Q_strdup(p->impact.spawns);
				p_id = strtok(buf, " ");
				while ( p_id != NULL){
					//Com_Printf("%s\n",p_id);
					PS_Spawn_Particles_From_Particle(p_id,p);
					p_id = strtok(NULL, " ");
				}
				Q_free(buf);
			}
			dead = true;
		}
		if (dead)
			Cprintt("i died from impact\n",test);

		if (p->python_function && p->python_module)
			Particle_Python_Call(p,p->python_module,p->python_function);

		if (dead){
			if (p->g_point.type){
				for (i=0;i<gravity_points_count;i++){
					if (p = gravity_points[i])
						break;
				}
				if (gravity_points[i+1] == NULL)
					gravity_points[i] = NULL;
				while (gravity_points[i+1]){
					gravity_points[i] = gravity_points[i+1];
					i++;
				}
				gravity_points_count--;
			}
			//Com_Printf("Particle is dead and got deleted\n");
			if (current == draw_particles_list){
				draw_particles_list = current->next;
				temp = current;
				current = draw_particles_list;
			}else{
				last->next = current->next;
				temp = current;
				current = current->next;
				//last = current;
			}
			//Q_free(temp->particle);
			Q_free(temp);
			particles_count--;
		}else{
			last	= current;
			current	= current->next;
		}
	}


}


void PS_Delete_Particle(ps_child_t *p){
	ps_plist_t *current,*last,*temp;
	int i;
	current = draw_particles_list;

	while (p != current->particle){
		last = current;
		current = current->next;
	}

	if (p->g_point.type){
		for (i=0;i<gravity_points_count;i++){
			if (p = gravity_points[i])
				break;
		}
		if (gravity_points[i+1] == NULL)
			gravity_points[i] = NULL;
		while (gravity_points[i+1]){
			gravity_points[i] = gravity_points[i+1];
			i++;
		}
		gravity_points_count--;
	}
	//Com_Printf("Particle is dead and got deleted\n");
	if (current == draw_particles_list){
		draw_particles_list = current->next;
		temp = current;
		current = draw_particles_list;
	}else{
		last->next = current->next;
		temp = current;
		current = current->next;
		//last = current;
	}
	Q_free(temp->particle);
	Q_free(temp);
	
	particles_count--;

}

void PS_Add_Particle_To_Draw_List (ps_child_t *p){
	ps_plist_t	*pps_list,*ps_list,*pl;
	int i;
	float v1,v2;
	//loat test;
	ps_list = draw_particles_list;
	
	if (particles_count >= PS_Limit.value){
		Q_free(p);
		return;
	}
	

	pl = malloc(sizeof(ps_plist_t));
	memset(pl,0,sizeof(ps_plist_t));
	pl->particle = p;
	particles_count++;


	for (i=0;i<4;i++){
		p->color.color1[i] = p->color.color1_s[i];
		p->color.color2[i] = p->color.color2_s[i];
	}

	// do some randomizing
	//VectorNormalize(p->direction);
	if (p->random_direction.type == 1){
		for (i=0;i<3;i++)
			p->direction[i] = p->direction[i] + lhrandom(p->random_direction.value1,p->random_direction.value2);
	} else if (p->random_direction.type == 2){
		v1 = lhrandom(p->random_direction.value1,p->random_direction.value2);
		v2 = lhrandom(p->random_direction.value3,p->random_direction.value4);
		PS_Rotate_Vector(p->direction,p->direction,v1,v2);
	} else if (p->random_direction.type == 3 || p->random_direction.type == 4){
		v1 = lhrandom(p->random_direction.value1,p->random_direction.value2);
		v2 = lhrandom(p->random_direction.value3,p->random_direction.value4);
		PS_Rotate_Vector(p->direction,p->normal,v1,v2);
		//Cprintv(p->direction,"direction");
	}

	VectorScale(p->direction,p->speed.value3,p->direction);
	

	if (p->random_origin.type){
		for (i=0;i<3;i++)
			p->origin[i] = p->origin[i] + lhrandom(p->random_origin.value1,p->random_origin.value2);
	}

	if (p->g_point.type)
		gravity_points[gravity_points_count++] = p;
	//Cprintv(p->normal,"normal in ps_add_particle");
	if (ps_list == NULL){
		draw_particles_list = pl;
		return;
	}
	if (p->light.unique_id)
		p->light.unique_id = unique_light_id++;
	while (ps_list){
		pps_list = ps_list;
		ps_list = ps_list->next;
	}
	pps_list->next = pl;
	return;

	

}

void PS_Spawn_Particles_From_Particle(char *identifier,ps_child_t *parent){
	ps_plist_t			*ps_rt;
	ps_child_t			*ps_found,*p;
	char				*string;
	char				*ptr;
	int					runs,i;
	char				cruns[20];

	ps_rt = loaded_particles_list;
	
	if (ps_rt == NULL){
		Com_Printf("No Particle in the Particle List\n");
		return;
	}
	ps_found = NULL;
	string = Q_strdup(identifier);
	
	ptr = strchr(string,'$');
	if (ptr != NULL){
	runs = strlen(identifier) - strlen(ptr);

	strncpy(cruns,identifier,runs);
	runs = atoi(cruns);
	ptr++;
	}
	//Com_Printf("%s %s %i\n",cruns,ptr,runs);
	

	if (ptr == NULL){
		ptr = string;
		runs = 1;
	}

	//malloc(sizeof(ps_plist_t
	while (ps_rt != NULL){
		if (!strcmp(ptr,ps_rt->particle->identifier)){
			ps_found = ps_rt->particle;
			break;
		}
		ps_rt=ps_rt->next;
	}
	if (ps_found == NULL){
		Com_Printf("No Particle with the identifier \"%s\" in the Particlelist\n",identifier);
		return;
	}

	for (i=0;i<runs;i++){
		p = malloc(sizeof(ps_child_t));
		memcpy(p,ps_found,sizeof(ps_child_t));
		VectorCopy(parent->origin,p->origin);
		VectorCopy(parent->direction,p->direction);
		VectorCopy(parent->normal,p->normal);
		p->starttime = r_refdef2.time;
		p->spawned_by = parent->unique_id;
		p->unique_id = unique_id++;
		PS_Add_Particle_To_Draw_List(p);
	}
	Q_free(string);
}

void PS_Spawn_Particles_From_Parent(char *identifier,ps_parent_t *parent){
	ps_plist_t			*ps_rt;
	ps_child_t			*ps_found,*p;
	ps_rt = loaded_particles_list;


	ps_found = NULL;

	if (ps_rt == NULL){
		Com_Printf("No Particle in the Particle List\n");
		return;
	}
	//malloc(sizeof(ps_plist_t
	while (ps_rt != NULL){
		if (!strcmp(identifier,ps_rt->particle->identifier)){
			ps_found = ps_rt->particle;
			break;
		}
		ps_rt=ps_rt->next;
	}
	if (ps_found == NULL){
		Com_Printf("No Particle with the identifier \"%s\" in the Particlelist\n",identifier);
		return;
	}

	p = malloc(sizeof(ps_child_t));
	memcpy(p,ps_found,sizeof(ps_child_t));
	VectorCopy(parent->origin,p->origin);
	VectorCopy(parent->direction,p->direction);
	//VectorScale(parent->direction,p->speed.value,p->direction);
	p->starttime = r_refdef2.time;
	p->spawned_by = 0;
	p->unique_id = unique_id++;
		
	PS_Add_Particle_To_Draw_List(p);
	

}

void PS_Spawn_Parent(char *identifier){

	ps_parent_list_t	*ps_rt;
	ps_parent_t			*ps_found;
	ps_rt = ps_parent_list;
	
	if (ps_rt == NULL){
		Com_Printf("No Parent in the Parentlist\n");
		return;
	}
	while (ps_rt != NULL){
		if (!strcmp(identifier,ps_rt->parent->identifier)){
			ps_found = ps_rt->parent;
			break;
		}
		ps_rt=ps_rt->next;
	}
	if (ps_rt == NULL){
		Com_Printf("No Parent with the identifier \"%s\" in the Parentlist\n",identifier);
		return;
	}
	PS_Spawn_Particles_From_Parent(ps_found->plist,ps_found);
}

void PS_Spawn_Particle_From_Console (void){
	ps_parent_t p;
	vec3_t forward,right,up;
	VectorCopy(cl.simorg,p.origin);
	AngleVectors (cl.simangles,forward, right, up);
	VectorMA(p.origin,1,forward,p.direction);
	VectorCopy(forward,p.direction);
	//VectorScale(p.direction,p.speed,p.direction);

	PS_Spawn_Particles_From_Parent(Cmd_Argv(1),&p);
}

void PS_Add_Particle(void){


}


void PS_Add_Gravity_point (void) {
	VectorCopy(cl.simorg,gravity_point[atoi(Cmd_Argv(1))].origin);
	gravity_point[atoi(Cmd_Argv(1))].gravity = atof(Cmd_Argv(2));
	gravity_point[atoi(Cmd_Argv(1))].distance = atof(Cmd_Argv(3));
}


/*
	everything will be zero unless its set
	bounce		- b dies_by_bounce bounce_count bounce_modifier "spawns_on_bounce"
	hit			- h dies_by_hit "spawns_on_hit"
	time		- t dies_by_time "spawns_on_time"
	direction	- d x y z - added to parents d
	origin		- o x y z - added to parents o
	gravity		- g modifier
	speed		- s modifier dies_by_speed speed_limit


*/

void PS_Edit_Particle_Type (void){
	ps_child_t	*p;
	ps_plist_t	*pc;
	int i,hash;
	hash = Com_HashKey(Cmd_Argv(1));

	pc = loaded_particles_list;
	while (pc){
		if (pc->particle->hash == hash && !strcasecmp (pc->particle->identifier, Cmd_Argv(1))){
			break;
		}
	pc=pc->next;
	}
	if (pc == NULL){
		Com_Printf("No Particle with the identifier \"%s\" was found.\n",Cmd_Argv(1));
	}
	
	hash = Com_HashKey(Cmd_Argv(2));
	Com_Printf("%i\n",hash);
	p = pc->particle;
	i=3;
	switch (hash){
		case pt_bounce:
			p->bounce.dies_by = atoi(Cmd_Argv(i++));
			p->bounce.value1 = atoi(Cmd_Argv(i++));
			p->bounce.value2 = atoi(Cmd_Argv(i++));
			p->bounce.value3 = atof(Cmd_Argv(i++));
			if (!strcmp(Cmd_Argv(i),"NULL"))
				p->bounce.spawns = NULL;
			else
				p->bounce.spawns = Q_strdup(Cmd_Argv(i++));
			break;
		case pt_hit:
			p->impact.dies_by = atoi(Cmd_Argv(i++));
			if (!strcmp(Cmd_Argv(i),"NULL"))
				p->impact.spawns= NULL;
			else
				p->impact.spawns = Q_strdup(Cmd_Argv(i++));
			break;
		case pt_time:
			p->time.dies_by = atoi(Cmd_Argv(i++));
			p->time.value1 = atof(Cmd_Argv(i++));
			p->time.value2 = atoi(Cmd_Argv(i++));
			break;
		case pt_direction:
			p->random_direction.type = atoi(Cmd_Argv(i++));
			p->random_direction.value1 = atof(Cmd_Argv(i++));
			p->random_direction.value2 = atof(Cmd_Argv(i++));
			p->random_direction.value3 = atof(Cmd_Argv(i++));
			p->random_direction.value4 = atof(Cmd_Argv(i++));

			//VectorSet(p->direction,atof(Cmd_Argv(i++)),atof(Cmd_Argv(i++)),atof(Cmd_Argv(i++)));
			break;
		case pt_origin:
			p->random_origin.type = atoi(Cmd_Argv(i++));
			p->random_origin.value1 = atof(Cmd_Argv(i++));
			p->random_origin.value2 = atof(Cmd_Argv(i++));
			p->random_origin.value3 = atof(Cmd_Argv(i++));
			//VectorSet(p->origin,atof(Cmd_Argv(i++)),atof(Cmd_Argv(i++)),atof(Cmd_Argv(i++)));
			break;
		case pt_gravity:
			p->g_modifier = atof(Cmd_Argv(i++));
			p->g_affected = atoi(Cmd_Argv(i++));
			p->g_point.type = atof(Cmd_Argv(i++));
			p->g_point.value1 = atof(Cmd_Argv(i++));
			p->g_point.value2 = atof(Cmd_Argv(i++));
			break;
		case pt_speed:
			p->speed.dies_by = atoi(Cmd_Argv(i++));
			p->speed.value1 = atof(Cmd_Argv(i++));
			p->speed.value2 = atof(Cmd_Argv(i++));
			p->speed.value3 = atof(Cmd_Argv(i++));
			if (!strcmp(Cmd_Argv(i),"NULL"))
				p->speed.spawns = NULL;
			else
				p->speed.spawns = Q_strdup(Cmd_Argv(i++));
			break;
		case pt_ival:
			p->interval.value1 = atof(Cmd_Argv(i++));
			p->interval.value2 = atof(Cmd_Argv(i++));
			p->interval.value3 = atof(Cmd_Argv(i++));
			if (!strcmp(Cmd_Argv(i),"NULL"))
				p->interval.spawns = NULL;
			else
				p->interval.spawns = Q_strdup(Cmd_Argv(i++));
			break;

		case pt_color:
			p->color.blends_by = atoi(Cmd_Argv(i++));
			p->color.color1_s[0] = atof(Cmd_Argv(i++));
			p->color.color1_s[1] = atof(Cmd_Argv(i++));
			p->color.color1_s[2] = atof(Cmd_Argv(i++));
			p->color.color1_s[3] = atof(Cmd_Argv(i++));
			p->color.color1_e[0] = atof(Cmd_Argv(i++));
			p->color.color1_e[1] = atof(Cmd_Argv(i++));
			p->color.color1_e[2] = atof(Cmd_Argv(i++));
			p->color.color1_e[3] = atof(Cmd_Argv(i++));
			p->color.color2_s[0] = atof(Cmd_Argv(i++));
			p->color.color2_s[1] = atof(Cmd_Argv(i++));
			p->color.color2_s[2] = atof(Cmd_Argv(i++));
			p->color.color2_s[3] = atof(Cmd_Argv(i++));
			p->color.color2_e[0] = atof(Cmd_Argv(i++));
			p->color.color2_e[1] = atof(Cmd_Argv(i++));
			p->color.color2_e[2] = atof(Cmd_Argv(i++));
			p->color.color2_e[3] = atof(Cmd_Argv(i++));
			break;

		case pt_sound:
			p->sound = S_PrecacheSound(Cmd_Argv(i));
			break;

		case pt_type:
			p->type = atoi(Cmd_Argv(i++));
			break;

		case pt_textures:
			p->texture = *GL_LoadPicImage(va("gfx/%s", Cmd_Argv(i)), Cmd_Argv(i), 0, 0, TEX_ALPHA | TEX_COMPLAIN);
			Com_Printf("%s %i\n",Cmd_Argv(i),p->texture);
			break;

		case pt_size:
			p->size = atof(Cmd_Argv(i++));
			p->growth = atof(Cmd_Argv(i++));
			break;

		case pt_light:
			p->light.unique_id = atoi(Cmd_Argv(i++));
			p->light.color = atoi(Cmd_Argv(i++));
			p->light.type = atoi(Cmd_Argv(i++));
			p->light.radius = atof(Cmd_Argv(i++));
			p->light.time = atof(Cmd_Argv(i++));
			p->light.custom= atoi(Cmd_Argv(i++));
			p->light.custom_color[0] = atof(Cmd_Argv(i++));
			p->light.custom_color[1] = atof(Cmd_Argv(i++));
			p->light.custom_color[2] = atof(Cmd_Argv(i++));
			break;

		case pt_rotation:
			p->rotation.type = atoi(Cmd_Argv(i++));
			p->rotation.value1 = atof(Cmd_Argv(i++));
			p->rotation.value2 = atof(Cmd_Argv(i++));
			p->rotation.value3 = atof(Cmd_Argv(i++));
			p->rotation.value4 = atof(Cmd_Argv(i++));
			break;

		case pt_python:
			p->python_module = Q_strdup(Cmd_Argv(i++));
			p->python_function = Q_strdup(Cmd_Argv(i++));
			break;
	}
	

}


void PS_Create_Particle_Type (void){
	ps_child_t	*p;
	ps_plist_t	*plist,*ppc,*pc;

	if (Cmd_Argc()<1){
		Com_Printf("We need an identifier\n");
		return;
	}
	p=malloc(sizeof(ps_child_t));
	memset (p, 0, sizeof(ps_child_t));
	plist=malloc(sizeof(ps_plist_t));
	memset (plist, 0, sizeof(ps_plist_t));
	p->identifier = Q_strdup(Cmd_Argv(1));
	p->hash = Com_HashKey(p->identifier);
	plist->particle = p;
	plist->next = NULL;
	if (loaded_particles_list == NULL){
		loaded_particles_list = plist;
		return;
	}

	pc = loaded_particles_list;
	while (pc){
		if (pc->particle->hash == p->hash && !strcasecmp (pc->particle->identifier, p->identifier)){
			//Com_Printf("%s %s\n",p->identifier,pc->particle->identifier);
			Com_Printf("A Particle with the identifier \"%s\" already exists.\n",p->identifier);
			free(p);
			free(plist);
			return;
		}
		ppc =pc;
		pc=pc->next;
	}

	ppc->next=plist;
	 
	return;
}

void PS_List_Particle_Types(void){
	ps_plist_t	*pslist;
	pslist = loaded_particles_list;
	while (pslist){
		Com_Printf("%s\n",pslist->particle->identifier);
		//Com_Printf("%i %i %i\n",(int)pslist->particle->color[0],(int)pslist->particle->color[1],(int)pslist->particle->color[2]);
		pslist=pslist->next;
	}
	return;
}

// rotates a vector certain degrees
void PS_Rotate_Vector (vec3_t dst,vec3_t org,float degree_x, float degree_y){
	vec3_t	forward,right,up,temp;
	float length;
	float angle_x,angle_y;
	

	mvd_vectoangles(org,temp);
	AngleVectors(temp,forward,right,up);
	length = forward[0] * forward[0] + forward[1] * forward[1] + forward[2] * forward[2];
	
	angle_x = temp[0] + degree_x;
	angle_y = temp[1] + degree_y;

	if (angle_y >= 90 && angle_y <= 270){
		if ( angle_x > 90 ){
			angle_x = 180 - angle_x;
			angle_y -= 180;
		}else if (angle_x < -90){
			angle_x = -180 - angle_x;
			angle_y -= 180;
		}
	}else if (angle_y < 90 || angle_y > 270){
		if ( angle_x > 90 ){
			angle_x = 180 - angle_x;
			angle_y += 180;
		}else if (angle_x < -90){
			angle_x = -180 - angle_x;
			angle_y += 180;
		}
		if (angle_y > 360)
			angle_y -= 360;
	}

	dst[0] = length * cos(DEG2RAD(angle_x)) * cos(DEG2RAD(angle_y));
	dst[1] = length * cos(DEG2RAD(angle_x)) * sin(DEG2RAD(angle_y));
	dst[2] = length * sin(DEG2RAD(angle_x));

}


void PS_Test (void){
	vec3_t	endorg;
	ps_child_t	p;
	return;
	Com_Printf("Test\n");

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_COLOR);
	glEnable(GL_TEXTURE_2D);
//	GL_Bind(p->texture.texnum);
	
	Cprintv(null,"null");
	mvd_vectoangles(null,endorg);
	Cprintv(cl.simangles,"simangles");
	Cprintv(endorg,"angles from nullvector");
	glPushMatrix();
	
		
	//glRotatef (-90, 1, 0, 0);	    // put Z going up
    //glRotatef (90,  0, 0, 1);	    // put Z going up
	//endorg[1] -= 270;

	glTranslatef(org[0], org[1], org[2]);
		
	if (endorg[1] > 270 || endorg[1] < 90){
		endorg[0] -= 90;
		if (endorg[0] < 0 )
			endorg[0] = -1 * endorg[0];
		else
			endorg[0] = 360 - endorg[0];
	}
	if (endorg[1] < 270 && endorg[1] > 90){
		endorg[0] -= 90;
		if (endorg[0] < 0 )
			endorg[0] = -1 * endorg[0];
		else 
			endorg[0] -= 270;
	}


	Cprintv(endorg,"angles");

	glRotatef (endorg[1], 0, 0, 1);
	glRotatef (endorg[0], 0, 1, 0);
	glRotatef (endorg[2], 1, 0, 0);
	glScalef(4, 4, 4);
	
		


	glColor4f(1,1,1,1);
	glBegin (GL_QUADS);
	glTexCoord2f (0,0);
	glVertex3f (-4, -4, 0);
	glTexCoord2f (1,0);
	glVertex3f (4, -4, 0);
	glTexCoord2f (1,1);
	glVertex3f (4, 4, 0);
	glTexCoord2f (0,1);
	glVertex3f (-4, 4, 0);
	glEnd();

	glRotatef(180,1,0,0);
	glBegin (GL_QUADS);
	glTexCoord2f (0,0);
	glVertex3f (-4, -4, 0);
	glTexCoord2f (1,0);
	glVertex3f (4, -4, 0);
	glTexCoord2f (1,1);
	glVertex3f (4, 4, 0);
	glTexCoord2f (0,1);
	glVertex3f (-4, 4, 0);
	glEnd();
			//And since quads seem to be one sided...
	
	glPopMatrix();
	glFlush();
	
	// draw the normal vector
	
	glDisable(GL_TEXTURE_2D);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glBegin(GL_POINTS);
	glColor3f(1,1,0);
	glVertex3fv(org);
	//Cprintv(p->origin,"origin");
	//Cprintv(p->direction,"direction");
	VectorMA(org,10,null,endorg);
	glVertex3fv(endorg);
	glEnd();
	glFlush();

	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_TEXTURE_2D);



}



void PS_Pcount (void){
	vec3_t	forward,right,up;
	Com_Printf("%i\n",particles_count);
	AngleVectors(cl.simangles,forward,right,up);
	VectorNormalize(forward);
	VectorCopy(forward,null);
	VectorCopy(cl.simorg,org);
	r_1 = atof(Cmd_Argv(1));
	r_2 = atof(Cmd_Argv(2));
	r_3 = atof(Cmd_Argv(3));
}
void Python_Init (void);
void PS_Init (void){

	

	Cvar_Register(&PS_Use_Me);
	Cvar_Register(&PS_Limit);
	
	Cmd_AddCommand("ps_list_particle_types",PS_List_Particle_Types);
	Cmd_AddCommand("ps_create_particle_type",PS_Create_Particle_Type);
	Cmd_AddCommand("ps_add",PS_Add_Particle);
	Cmd_AddCommand("ps_gpoint",PS_Add_Gravity_point);
	Cmd_AddCommand("ps_edit_particle_type",PS_Edit_Particle_Type);
	Cmd_AddCommand("ps_spawn_particle_from_console",PS_Spawn_Particle_From_Console);
	Cmd_AddCommand("ps_pcount",PS_Pcount);
}

void PS_Check_For_Quad(void){
	int i;
	ps_parent_t p;
	
	//Com_Printf("Test\n");
	for (i=0;i<32;i++){
		if (!cl.players[i].spectator && cl.players[i].name[0] && cl.players[i].stats[STAT_ITEMS] & IT_QUAD){
			//Com_Printf("Test1\n");
			VectorCopy(cl.frames[cl.parsecount & UPDATE_MASK].playerstate[i].origin,p.origin);
			//VectorCopy(cl.frames[cl.parsecount & UPDATE_MASK].playerstate[i].velocity,p.direction);
			VectorSet(p.direction,0,0,0);
			PS_Spawn_Particles_From_Parent("player_quad",&p);
		}
	}
	
}

void PS_Spawn_From_ParseTEnt(vec3_t origin,char *identifier){
	ps_parent_t p;
	VectorSet(p.direction,0,0,0);
	VectorCopy(origin,p.origin);
	PS_Spawn_Particles_From_Parent(identifier,&p);

}



// Python hooks

	
// in python.c
void Python_Call_Particle(char *module, char *function,ps_child_t *p);

// calls the python function
void Particle_Python_Call(ps_child_t *p,char *module, char *function){
	
	python_particle = p;
	Python_Call_Particle(module,function,p);
	
}


// Color Set from python
void Python_Callback_Color(int blends,float *c){
	ps_child_t *p;
	int i;

	p=python_particle;

//	p->color.blends_by = blends;

	if (blends == 1)
		for (i=0;i<4;i++)
			p->color.color1[i] = *c++;
	if (blends == 2)
		for (i=0;i<4;i++)
			p->color.color2[i] = *c++;
	if (blends == 3)
		for (i=0;i<4;i++)
			p->color.color1_s[i] = *c++;
	if (blends == 4)
		for (i=0;i<4;i++)
			p->color.color1_e[i] = *c++;
	if (blends == 5)
		for (i=0;i<4;i++)
			p->color.color2_s[i] = *c++;
	if (blends == 6)
		for (i=0;i<4;i++)
			p->color.color2_e[i] = *c++;
}

// spawns the particles in char
void Python_Callback_Spawn(char *s){
	

	PS_Spawn_Particles_From_Particle(s,python_particle);

}

void Python_Callback_Type(int type){

	python_particle->type = type;

}



