/*

	Depth of Field Render Path

*/

#include "quakedef.h"
#include "mvd_cam.h"
#include <time.h>
#include <string.h>
#include "glext.h"
#include <GL/glaux.h>
#include "gl_framebuffer.h"

int its_time = 0;
    int jitter;
	    GLint viewport[4];

		cvar_t r_dof = {"r_dof","0"};
		cvar_t r_dof_jitter = {"r_dof_jitter","2"};

void accFrustum(GLdouble left, GLdouble right, GLdouble bottom, 
   GLdouble top, GLdouble nnear, GLdouble ffar, GLdouble pixdx, 
   GLdouble pixdy, GLdouble eyedx, GLdouble eyedy, GLdouble focus)
{
   GLdouble xwsize, ywsize; 
   GLdouble dx, dy;
   GLint viewport[4];

   glGetIntegerv (GL_VIEWPORT, viewport);
	
   xwsize = right - left;
   ywsize = top - bottom;
	
   dx = -(pixdx*xwsize/(GLdouble) viewport[2] + eyedx*nnear/focus);
   dy = -(pixdy*ywsize/(GLdouble) viewport[3] + eyedy*nnear/focus);
	//dx = dy =- -.02 ;
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glFrustum (left + dx, right + dx, bottom + dy, top + dy, nnear, ffar);
   //Com_Printf("%f %f %f %f %f %f %f %f %f %f %f \n", left,  right,  bottom,  top,  dx,dy,  pixdx,  pixdy,  eyedx,  eyedy,  focus);
   //glFrustum (left +dx,right +dx ,bottom +dy,top +dy,nnear,ffar);

   //######################################################
   // You need to modify this part for the assignment 3.
   //glMatrixMode(GL_MODELVIEW);
   //glLoadIdentity();
   //glTranslatef (-r_refdef.vieworg[0], -r_refdef.vieworg[1], -r_refdef.vieworg[2]);
   //glTranslatef (-eyedx, -eyedy, 0.0);
   //######################################################
	//Com_Printf("%f %f\n",eyedx,eyedy);
   //glTranslatef (-(r_refdef.vieworg[0] + eyedx), -(r_refdef.vieworg[1] + eyedy), -r_refdef.vieworg[2]);
}

void accPerspective(GLdouble fovy, GLdouble aspect, 
   GLdouble nnear, GLdouble ffar, GLdouble pixdx, GLdouble pixdy, 
   GLdouble eyedx, GLdouble eyedy, GLdouble focus)
{
	GLdouble left,right,bottom,top;

	top = nnear * tan(fovy * M_PI / 360.0);
	bottom = -top;

	left = bottom *aspect;
	right = top * aspect;


	//Com_Printf("%i %f %f %f %f %f %f %f %f %f %f %f\n",jitter,left, right, bottom, top, nnear, ffar,pixdx, pixdy, eyedx, eyedy, focus);
	accFrustum (left, right, bottom, top, nnear, ffar,
				pixdx, pixdy, eyedx, eyedy, focus);
}

float j8[8][2] = {{0.5625, 0.4375}, {0.0625, 0.9375}, {0.3125, 0.6875}, {0.6875, 0.8125}, {0.8125, 0.1875}, {0.9375, 0.5625}, {0.4375, 0.0625}, {0.1875, 0.3125}};
//float j8[8][2] = {{2, 2}, {3, 3}, {5, 5}, {1, 1}, {8, 8}, {3, 3}, {9, 9}, {2, 2}};


void SCR_UpdateScreen (void);
void GL_EndRendering (void);

void R_RenderScene (void);
void R_RenderDlights (void);
void R_DrawParticles (void);


void R_SetupGL_b (void) {
	float screenaspect;
	extern int glwidth, glheight , MVD_CURRENTVIEW;
	extern cvar_t beziers_autodist;
	int x, x2, y2, y, w, h, farclip;
	extern vec3_t	lookat_pos;

	extern vec3_t cam_pos,view_pos;
	float dist;
	//glViewport (0, 0, glwidth, glheight);
	// set up viewpoint
	//glMatrixMode(GL_PROJECTION);
    //glLoadIdentity ();
	x = r_refdef.vrect.x * glwidth / vid.width;
	x2 = (r_refdef.vrect.x + r_refdef.vrect.width) * glwidth / vid.width;
	y = (vid.height-r_refdef.vrect.y) * glheight / vid.height;
	y2 = (vid.height - (r_refdef.vrect.y + r_refdef.vrect.height)) * glheight / vid.height;

	// fudge around because of frac screen scale
	if (x > 0)
		x--;
	if (x2 < glwidth)
		x2++;
	if (y2 < 0)
		y2--;
	if (y < glheight)
		y++; 

	w = x2 - x;
	h = y - y2;

	

    screenaspect = (float)r_refdef.vrect.width/r_refdef.vrect.height;
	farclip = max((int) r_farclip.value, 4096);
	if(beziers_autodist.value)
		dist = sqrt(pow((cam_pos[0]- view_pos[0]),2) + pow((cam_pos[1] - view_pos[1]),2) + pow((cam_pos[2] - view_pos[2]),2));
	else
		dist = sqrt(pow((cam_pos[0]- lookat_pos[0]),2) + pow((cam_pos[1] - lookat_pos[1]),2) + pow((cam_pos[2] - lookat_pos[2]),2));
		accPerspective (r_refdef.fov_y, 
			screenaspect, 
			4.0, max((int) r_farclip.value, 4096), 0,0,j8[jitter][0],j8[jitter][1],dist);
		//Com_Printf("%i\n",jitter);

	glCullFace(GL_FRONT);

	glMatrixMode(GL_MODELVIEW);
    glLoadIdentity ();

    glRotatef (-90, 1, 0, 0);	    // put Z going up
    glRotatef (90,  0, 0, 1);	    // put Z going up
    glRotatef (-r_refdef.viewangles[2], 1, 0, 0);
    glRotatef (-r_refdef.viewangles[0], 0, 1, 0);
    glRotatef (-r_refdef.viewangles[1], 0, 0, 1);
	glTranslatef (-(r_refdef.vieworg[0]+ r_dof_jitter.value*j8[jitter][0]), -(r_refdef.vieworg[1] + r_dof_jitter.value*j8[jitter][1]), -r_refdef.vieworg[2]);

	glGetFloatv (GL_MODELVIEW_MATRIX, r_world_matrix);

	// set drawing parms
	if (gl_cull.value)
		glEnable(GL_CULL_FACE);
	else
		glDisable(GL_CULL_FACE);

	if (MVD_CURRENTVIEW == 0){
		//glClear( GL_DEPTH_BUFFER_BIT );
	}

	glDepthRange (gldepthmin, gldepthmax); 

	glDisable(GL_BLEND);
	glDisable(GL_ALPHA_TEST);

	glHint (GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glHint (GL_FOG_HINT,GL_NICEST);

	glEnable(GL_DEPTH_TEST);
}
void SCR_CalcRefdef (void);
// Replaces SCR_UpdateScreen
void DOF_Main_Loop(void){
	extern fb_s main_fb;
	extern frame_t *view_frame;
    glGetIntegerv (GL_VIEWPORT, viewport);
    glClear(GL_ACCUM_BUFFER_BIT);
	r_refdef2.time = cl.time;
	//Framebuffer_Enable(&main_fb);
    for (jitter = 0; jitter < 8; jitter++) {
	//	Com_Printf("%i\n",jitter);
	//glClearColor(0,0,0,1);
	//glClear(GL_DEPTH_BUFFER_BIT|GL_COLOR_BUFFER_BIT);
	glClear(GL_DEPTH_BUFFER_BIT|GL_COLOR_BUFFER_BIT);
	//jitter =7;
	MVD_CURRENTVIEW = 0;
	
	view_frame = &cl.frames[cl.validsequence & UPDATE_MASK];
	SCR_CalcRefdef ();
	R_RenderScene ();
	R_RenderDlights ();
	
	R_DrawParticles ();
	R_BrightenScreen ();
	V_UpdatePalette ();
	R_PolyBlend ();
	if (jitter == 0)
		glAccum(GL_LOAD,0.125);
	else
		glAccum(GL_ACCUM, 0.125);

	if ( jitter == 7){
		glAccum(GL_RETURN,1);
		}
	}
	//Framebuffer_Disable(&main_fb);
	MVD_CURRENTVIEW = 1;
	//Framebuffer_Draw(&main_fb);
	GL_EndRendering (); // we flip the buffer
	CL_EmitEntities();
}

void DOF_Init(void){
	Cvar_Register(&r_dof);
	Cvar_Register(&r_dof_jitter);
}
	







