/*
	$Id: sens_analyzer.c,v 1.1 2007/02/12 04:31:57 jogi Exp $
*/

#include "common.h"
#include "quakedef.h"

#define X 0
#define Y 1

float max_vel[2];
float max_dist;
vec3_t	last_angle,last_pos;
cvar_t	sa_enable = {"sa_enable","0"};
cvar_t	sa_show	=	{"sa_show","0"};
cvar_t	sa_show_x	=	{"sa_show_x","0"};
cvar_t	sa_show_y	=	{"sa_show_y","0"};
cvar_t	sa_frames	=	{"sa_frames","0"};
cvar_t	sa_limit		=	{"sa_limit","200"};


void sa_frame_f(void){
	float x,y,distance;
	extern int spec_track;
	if (!sa_enable.value)
		return;
	if (!last_angle[0] && !last_angle[1]){
		VectorCopy(r_refdef.viewangles,last_angle);
		VectorCopy(r_refdef.vieworg,last_pos);
			return;
	}
	if ((distance = sqrt(pow((r_refdef.vieworg[0]- last_pos[0]),2) + pow((r_refdef.vieworg[1]- last_pos[1]),2) + pow((r_refdef.vieworg[2]- last_pos[2]),2))) > 50 || cl.stats[STAT_HEALTH] <= 0 || (cls.frametime != 0.01 && !sa_frames.value )){
		/*VectorCopy(r_refdef.viewangles,last_angle);
		VectorCopy(r_refdef.vieworg,last_pos);*/
		//Com_Printf("%f %f %f %f\n",distance,cls.frametime,last_angle[0] - r_refdef.viewangles[0],last_angle[1] - r_refdef.viewangles[1]);
		last_pos[0] = 0;
		last_pos[1] = 0;
		last_pos[2] = 0;
		last_angle[0] = 0;
		last_angle[1] = 0;
		last_angle[2] = 0;
		VectorCopy(r_refdef.viewangles,last_angle);
		VectorCopy(r_refdef.vieworg,last_pos);
		if (distance > max_dist)
			max_dist = distance;
		return;
	}
	
	if (distance > max_dist)
		max_dist = distance;

	x = sqrt(pow(last_angle[0],2) - pow(r_refdef.viewangles[0],2));
	if (x < 0)
		x = -1 * x;
	if (sa_frames.value)
		x = (x/cls.frametime) * 0.01;
	if (x > max_vel[X] && x < sa_limit.value)
		max_vel[X] = x;
	y = sqrt(pow(last_angle[1],2) - pow(r_refdef.viewangles[1],2));
	if (y < 0)
		y = -1 * y;
	if (sa_frames.value)
		y = (y/cls.frametime) * 0.01;
	if (y > max_vel[Y] && y < sa_limit.value){
		max_vel[Y] = y;
		Com_Printf("%f %f %f\n",((r_refdef.viewangles[1],last_angle[1],sqrt(pow(last_angle[1],2) - pow(r_refdef.viewangles[1],2)))/cls.frametime)* 0.01);
		//Com_Printf("%f %f %f\n",
		Cbuf_AddText(va("set sa_value %f\n",y));
	}
	//Com_Printf("%f %f %f\n",r_refdef.viewangles[1],last_angle[1],sqrt(pow(last_angle[1],2) - pow(r_refdef.viewangles[1],2)));
	
	VectorCopy(r_refdef.viewangles,last_angle);
	VectorCopy(r_refdef.vieworg,last_pos);

}

void sa_restart_f(void){
	max_vel[X] = 0;
	max_vel[Y] = 0;
}

void sa_show_f(void){
	int x,y;
	if (!sa_show.value)
		return;
	x = sa_show_x.value;
	y = sa_show_y.value;
	Draw_String(x,y,   va("pitch :%5.5f\n",max_vel[X]));
	Draw_String(x,y+8, va("yaw   :%5.5f\n",max_vel[Y]));
	Draw_String(x,y+16,va("dist  :%5.5f\n",max_dist));
	Draw_String(x,y+24,va("pos   :%5.5f %5.5f %5.5f\n",r_refdef.vieworg[0],r_refdef.vieworg[1],r_refdef.vieworg[2]));
}

void sa_init(void){
	Cmd_AddCommand("sa_restart",sa_restart_f);
	Cvar_Register(&sa_enable);
	Cvar_Register(&sa_show);
	Cvar_Register(&sa_show_x);
	Cvar_Register(&sa_show_y);
	Cvar_Register(&sa_frames);
	Cvar_Register(&sa_limit);

}


