/*

	Shaders
	Most of it stolen from the sauerbraten engine (thx aardappel =]) (uh and all hail the aard !)

*/

#include "quakedef.h"
#include "mvd_cam.h"
#include <time.h>
#include <string.h>
#include <sys/stat.h>
#include "glext.h"
#include <GL/glaux.h>
#include "shaders.h"
#include "shaders_local.h"

int current_shader = 0;
int current_shader_1 = 0;

cvar_t	shader_1	=	{"shader_1","!!ARBfp1.0 TEX result.color, fragment.texcoord[0], texture[0], 2D;END"};
cvar_t	shader_2	=	{"shader_2","!!ARBfp1.0 TEX result.color, fragment.texcoord[0], texture[0], 2D;END"};
cvar_t	shader_enable= {"shader_enable","0"};

cvar_t	shader_fullscreen	=	{"shader_fullscreen",""};

int Shader_Lookup(char *name){
	int i;
	for (i=0;i<max_shaders;i++)
		if (!strcmp(name,shaders[i].name))
			return i;

	return -1;
}

void Shader_Param(void){
	int i,j;
	int param;
	i = Shader_Lookup(Cmd_Argv(1));
	if (i == -1){
		Com_Printf("A shader with the name %s does not exist\n",Cmd_Argv(1));
		return;
	}
	param =0 ;
	for (j=2;j<Cmd_Argc();j++)
		shaders[i].param[param++] = atof(Cmd_Argv(j));
	
}

void Shaders_Load (void){
	int shader_num;
	GLint err;
	int i,j;
	int type;
	GLuint *shader;
	char *prog;
	int param;
	if (!strlen(Cmd_Argv(1))){
		Com_Printf("Please supply a shader number\n");
		return;
	}
	shader_num = Shader_Lookup(Cmd_Argv(1));
	if (shader_num != -1 ){
		Com_Printf("Shader already exists so we delete it :D\n");
		i = shader_num;
		if (shaders[i].ps)	
			glDeletePrograms_(1,&shaders[i].ps);
		if (shaders[i].vs)
			glDeletePrograms_(1,&shaders[i].vs);
	}else if (shader_num == -1){
		for (i=0;i<max_shaders;i++)
			if (shaders[i].name[0] == 0)
				break;
		shader_num = i;
		strcpy(shaders[i].name,Cmd_Argv(1));

	}
	Com_Printf("shader count %i\n",shader_num);

	for (j=2;j<Cmd_Argc();j++){
		type = 0;
		if (strstr(Cmd_Argv(j),"!!ARBfp")){
			type = GL_FRAGMENT_PROGRAM_ARB;
			Com_Printf("I have a pixel shader\n");
			shader = &shaders[i].ps;
			prog = "Pixel shader";
			param =0 ;
		}else if  (strstr(Cmd_Argv(j),"!!ARBvp")){
			type = GL_VERTEX_PROGRAM_ARB;
			Com_Printf("I have a vertex shader\n");
			shader = &shaders[i].vs;
			prog = "Vertex shader";
			param =0 ;
		}else {
			if (param <4)
				break;
			Com_Printf("%s\n",Cmd_Argv(j));
			shaders[i].param[param++] = atof(Cmd_Argv(j));
		}
		if (type){
			glEnable(type);
			glGenPrograms_(1,shader);
			glBindProgram_(type,*shader);
			glProgramString_(type,GL_PROGRAM_FORMAT_ASCII_ARB,(GLsizei)strlen(Cmd_Argv(j)),Cmd_Argv(j));
			glDisable(type);
			glGetIntegerv(GL_PROGRAM_ERROR_POSITION_ARB, &err);
			if(err!=-1){
				Com_Printf("%s fucked Up !\n",prog);
				Com_Printf("ERROR : %s",glGetString(GL_PROGRAM_ERROR_STRING_ARB));
				shaders[i].name[0] = 0;
				return;
			}
		}
	}
}


void Shaders_Init (void){

	const char *exts = (char *)glGetString(GL_EXTENSIONS);
	Com_Printf("Initializing Shader\n");
	if(!strstr(exts, "GL_ARB_vertex_program") || !strstr(exts, "GL_ARB_fragment_program"))
	{
		Com_Printf("Shaders not available\n");
		return;
	}
	else
	{
		glGenPrograms_ =			(PFNGLGENPROGRAMSARBPROC)			wglGetProcAddress("glGenProgramsARB");
		glDeletePrograms_ =			(PFNGLDELETEPROGRAMSARBPROC)		wglGetProcAddress("glDeleteProgramsARB");
		glBindProgram_ =			(PFNGLBINDPROGRAMARBPROC)			wglGetProcAddress("glBindProgramARB");
		glProgramString_ =			(PFNGLPROGRAMSTRINGARBPROC)			wglGetProcAddress("glProgramStringARB");
		glProgramEnvParameter4f_ =  (PFNGLPROGRAMENVPARAMETER4FARBPROC) wglGetProcAddress("glProgramEnvParameter4fARB");
		glProgramEnvParameter4fv_ = (PFNGLPROGRAMENVPARAMETER4FVARBPROC)wglGetProcAddress("glProgramEnvParameter4fvARB");
		Com_Printf("Shaders available\n");
	};
	Cvar_Register(&shader_1);
	Cvar_Register(&shader_2);
	Cvar_Register(&shader_enable);
	//Cmd_AddCommand("shaders_load",Shaders_Load);
	Cvar_Register(&shader_fullscreen);
	Cmd_AddCommand("shader",Shaders_Load);
	Cmd_AddCommand("shader_param",Shader_Param);


}

void bindshader(shader_t *s){
	return;
	glBindProgram_(GL_VERTEX_PROGRAM_ARB,   s->vs);
	glBindProgram_(GL_FRAGMENT_PROGRAM_ARB, s->ps);
}

void Shader_Enable (GLint tex){
	if (!shader_enable.value)
		return;
	if (shaders[tex].vs){
	glEnable(GL_VERTEX_PROGRAM_ARB);
	glBindProgram_(GL_VERTEX_PROGRAM_ARB,shaders[tex].vs);
	}
	if (shaders[tex].ps){
	glEnable(GL_FRAGMENT_PROGRAM_ARB);
	glBindProgram_(GL_FRAGMENT_PROGRAM_ARB,shaders[tex].ps);
	}
	glProgramEnvParameter4f_(GL_FRAGMENT_PROGRAM_ARB,0,shaders[tex].param[0],shaders[tex].param[1],shaders[tex].param[2],shaders[tex].param[3]);
	
	//glProgramEnvParameter4f_(GL_FRAGMENT_PROGRAM_ARB, 0, tex, tex, tex, tex);
	//glProgramEnvParameter4f_(GL_FRAGMENT_PROGRAM_ARB, 1, tex, tex, tex, tex);
	


}

void Shader_Disable (void){
	if (!shader_enable.value)
		return;
	glDisable(GL_FRAGMENT_PROGRAM_ARB);
	glDisable(GL_VERTEX_PROGRAM_ARB);
}


