

#ifdef USE_STAT

#include "quakedef.h"
#include "winquake.h"
#include "mvd_cam.h"
#include "resource.h"
#include "windows.h"
//#include <QtGui/QApplication>


extern c_curve_t cameras[max_cameras];
extern c_curve_t views[max_cameras];
extern int selected_cam,selected_view,wich_one;
double lasttime;
extern HWND		mainwindow, dibwindow,subwindow;
c_curve_t *current_curve;
	int *num;


#define max_editboxes 40
#define max_buttons 40
#define max_checkboxes 40
#define max_comboboxes 40

int editboxes	=	0;
int buttons		=	0;
int checkboxes	=	0;
int comboboxes	=	0;
int ebident = 2000;
int btident = 3000;
int cbident = 4000;
int	coident	= 5000;
int lastnum ,lasttype ;
int update_subwindow = 0;

typedef struct editboxes_s {
	HWND hwnd;
	int identifier;
	char buffer[256];
	double	*fptr;
	int		*iptr;
	char	*cptr;
	char	string[1024];
	float		min;
	float		max;
	int		usemm;
	
}editboxes_t;

editboxes_t editbox[max_editboxes];

typedef struct buttons_s {
	HWND hwnd;
	int identifier;
	char command[256];
	void	(*function)(void);
} buttons_t;

buttons_t button[max_buttons];


typedef struct checkbox_s {
	HWND hwnd;
	int identifier;
	char text[256];
	int state;
	int **variable;
} checkbox_t;

checkbox_t checkbox[max_checkboxes];

typedef struct combobox_s {
	HWND hwnd;
	int identifier;
	int selection;
	int *variable;
} combobox_t;
combobox_t combobox[max_comboboxes];

lastnum = 0;
lasttype  = 0;

void Com_WPrint(char *string,int x,int y, HDC hdc){
	SetBkMode(hdc, TRANSPARENT);
	TextOut(hdc,x,y,string,strlen(string));
}

void Create_Combobox(char *string,int *variable, int x, int y, int width, int height,int identifier){
	int i;
	for (i = 0 ; i<comboboxes;i++)
		if (combobox[i].identifier == identifier){
			return;
		}
	
	combobox[comboboxes].variable = variable;
	combobox[comboboxes].identifier = identifier;
	combobox[comboboxes].hwnd = CreateWindow(
					"COMBOBOX", 
					string, 
					WS_VISIBLE | WS_CHILD | CBS_DROPDOWNLIST , 
					x, 
					y, 
					width, 
					height, 
					subwindow, 
					(HMENU)identifier, 
					(HINSTANCE)GetWindowLong(subwindow, GWL_HINSTANCE), 
					NULL);
		SendMessage(combobox[comboboxes ].hwnd, CB_ADDSTRING, 0, (LPARAM)"Cameras");
		SendMessage(combobox[comboboxes ].hwnd, CB_ADDSTRING, 0, (LPARAM)"Views");
		SendMessage(combobox[comboboxes ].hwnd, CB_SETCURSEL, 0, 0);
		comboboxes++;
}

void Combobox_Process(int identifier, int selection){
	int i;

	for (i=0;i<comboboxes;i++)
		if (combobox[i].identifier == identifier)
			break;


	combobox[i].selection = SendMessage(combobox[i].hwnd,CB_GETCURSEL,0,0);
	*combobox[i].variable = combobox[i].selection;



}

void Create_Checkbox(char *string, int state,int *variable,int x, int y, int width, int height , int identifier){
	int i;
	for (i = 0 ; i<checkboxes;i++)
		if (checkbox[i].identifier == identifier){
			return;
		}
	checkbox[checkboxes].identifier = identifier;
	checkbox[checkboxes].hwnd	= CreateWindow(
								"BUTTON",
								string,
								WS_VISIBLE | WS_CHILD | BS_CHECKBOX,
								x,
								y,
								width,
								height,
								subwindow,
								(HMENU)identifier,
								(HINSTANCE)GetWindowLong(subwindow, GWL_HINSTANCE),
								NULL);
	checkbox[checkboxes].state = state;
	checkbox[checkboxes].variable = variable;
	SendMessage(checkbox[i].hwnd,BM_SETCHECK,checkbox[i].state,0);
	checkboxes++;
}

void Create_Button(char *string,char *command,void *function, int x , int y, int width, int height, int identifier){

	int i;
	for (i = 0 ; i<buttons;i++)
		if (button[i].identifier == identifier){
			return;
		}

	button[buttons].identifier = identifier;
	button[buttons].hwnd	= CreateWindow(
								"BUTTON",
								string,
								WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
								x,
								y,
								width,
								height,
								subwindow,
								(HMENU)identifier,
								(HINSTANCE)GetWindowLong(subwindow, GWL_HINSTANCE),
								NULL);
	if (command)
		strcpy(button[buttons].command,command);
	if (function)
		button[buttons].function = function;
	buttons++;
}
void Button_Execute(int identifier){
	int i;
	int type = 0;
	
	for (i=0;i<buttons;i++)
		if (button[i].identifier == identifier){
			type = 1;
			break;
		}
		
	if (!type){
		for (i=0;i<checkboxes;i++){
			if (checkbox[i].identifier == identifier){
				type = 2;
				break;
			}
		}
	}

	if (type == 1){
		if (strlen(button[i].command))
			Cbuf_AddText(button[i].command);
		if (button[i].function)
			button[i].function();
		
	}else if (type == 2){
		checkbox[i].state = !checkbox[i].state;
		*checkbox[i].variable = checkbox[i].state;
		//SendMessage(checkbox[i].hwnd,BM_SETCHECK,checkbox[i].state,0);
	}


}

void Create_Editbox(char *string,int x, int y, int width, int height, int identifier, int *iptr, double *fptr, char *cptr,float min,float max, int usemm){
	int i ;
	for (i = 0;i<=editboxes; i++){
		if (editbox[i].identifier == identifier){
			return;
		}
	}
	editbox[editboxes].min = min;
	editbox[editboxes].max = max;
	editbox[editboxes].identifier = identifier;
	editbox[editboxes].usemm = usemm;
	editbox[editboxes].hwnd= CreateWindow(
					"EDIT",
					string,
					WS_VISIBLE | WS_CHILD | WS_TILED |WS_DLGFRAME | ES_WANTRETURN ,
					x,
					y,
					width,
					height,
					subwindow,
					(HMENU)identifier,
					(HINSTANCE)GetWindowLong(subwindow, GWL_HINSTANCE),
					NULL);
	if (cptr != NULL)
		editbox[editboxes].cptr = cptr;
	if (iptr != NULL)
		editbox[editboxes].iptr = iptr;
	if (fptr != NULL)
		editbox[editboxes].fptr = fptr;

	
	if (editbox[editboxes].iptr != NULL)
		sprintf(editbox[editboxes].string,"%i",iptr);
	if (editbox[editboxes].fptr != NULL)
		sprintf(editbox[editboxes].string,"%f",fptr);
	if (editbox[editboxes].cptr != NULL)
		sprintf(editbox[editboxes].string,"%s",cptr);
	
	editboxes++;
}

void ChangeEditbox(char *string,int identifier){
	int i;
	for (i=0;i<editboxes;i++)
		if (editbox[i].identifier == identifier)
			break;


	strcpy(editbox[i].string,string);


	if (editbox[i].iptr != NULL){
		*editbox[i].iptr = atoi(editbox[i].string);
		if (editbox[i].usemm){
			if (*editbox[i].iptr < (int)editbox[i].min)
				*editbox[i].iptr = (int)editbox[i].min;
			if (*editbox[i].iptr > (int)editbox[i].max)
				*editbox[i].iptr = (int)editbox[i].max;
		}

	}

	if (editbox[i].fptr != NULL){
		*editbox[i].fptr = atof(editbox[i].string);
		if (editbox[i].usemm){
			if (*editbox[i].fptr < editbox[i].min)
				*editbox[i].fptr = editbox[i].min;
			if (*editbox[i].fptr > editbox[i].max)
				*editbox[i].fptr = editbox[i].max;
		}
	}



}

void Editbox_Change(void){

}

BOOL Destroy_Window (HWND hwnd){
	return DestroyWindow(hwnd);
}

void CL_Quit_f (void);
void Create_SubWindow(void);
void Update_SubWindow(void){
	int i;

	
	if (!wich_one){
		current_curve=&cameras[selected_cam];
		num = &selected_cam;
	}else{
		current_curve=&views[selected_view];
		num = &selected_view;
	}
	if (*num == lastnum && lasttype == wich_one && !update_subwindow ){
		update_subwindow = 0;
		return;
	}else{
		lastnum = *num;
		lasttype = wich_one;
		update_subwindow = 0;
	}

	for (i=0;i<editboxes;i++){
		if (editbox[i].iptr != 0)
			if (*editbox[i].iptr != atoi(editbox[i].string)){
				SetWindowText(editbox[i].hwnd,va("%i",*editbox[i].iptr));
			}

			if (editbox[i].fptr != 0){
				if (*editbox[i].fptr != atof(editbox[i].string)){
					SetWindowText(editbox[i].hwnd,va("%f",*editbox[i].fptr));
				}
			}
	}

	for (i=0;i<checkboxes;i++){
		SendMessage(checkbox[i].hwnd,BM_SETCHECK,(WPARAM)*checkbox[i].variable,0);
		checkbox[i].state = *checkbox[i].variable;
	}

	for (i=0;i<comboboxes;i++){
		SendMessage(combobox[i].hwnd, CB_SETCURSEL, *combobox[i].variable, 0);
	}


}

void Create_SubWindow(void){
	PAINTSTRUCT ps;
	HDC hdd ;
	extern HWND subwindow;
	int i =0;
	int j;
	
	char *what;

	char arg[1024];
	char arg1[1024];
	hdd = BeginPaint(subwindow, &ps);
	if (!wich_one){
		current_curve=&cameras[selected_cam];
		what = "Cameras";
		num = &selected_cam;
	}else{
		current_curve=&views[selected_view];
		what = "Views";
		num = &selected_view;
	}

	if (*num != lastnum || lasttype != wich_one || update_subwindow == 1){
		for (j=0;j<editboxes;j++){
			Destroy_Window(editbox[j].hwnd);
			editbox[j].identifier = -1;
		}
		ebident = 2000;
		editboxes = 0;

		for (j=0;j<buttons;j++){
			Destroy_Window(button[j].hwnd);
			button[j].identifier = -1;
		}
		btident = 3000;
		buttons = 0;

		for (j=0;j<checkboxes;j++){
			Destroy_Window(checkbox[j].hwnd);
			checkbox[j].identifier = -1;
		}
		cbident = 4000;
		checkboxes = 0;

		lastnum = *num;
		lasttype = wich_one;
		update_subwindow = 0;
		
	}
	i=0;
	Com_WPrint("My status window :D",0,14*i++,hdd);
	Create_Combobox("What !",&wich_one,0,14*i++,200,12,coident);
	sprintf(arg,"Number: ");
	Com_WPrint(arg,0,20*i++,hdd);
	sprintf(arg1,"%i",*num);
	Create_Editbox(arg1,strlen("Number     :")*8 + 4 * 8,20*(i-1),strlen(arg1)* 8 + 4 * 8,20,ebident ,num,NULL,NULL,0,39,1);
	Create_Checkbox("Enable",current_curve->enable,&current_curve->enable,0,20*i++,64,20,cbident);
	Create_Checkbox("Show",current_curve->showme,&current_curve->showme,0,20*i++,64,20,cbident+1);

	Com_WPrint("Starttime  :",0,20*i++,hdd);
	sprintf(arg1,"%f",current_curve->starttime);
	Create_Editbox(arg1,strlen("Starttime  :")*8 + 4 * 8,20*(i-1),strlen(arg1)* 8 + 4 * 8,20,ebident +1,NULL,&current_curve->starttime,NULL,0,12000,1);

	sprintf(arg,"Stoptime  :");
	Com_WPrint(arg,0,20*i++,hdd);
	sprintf(arg1,"%f",current_curve->stoptime);
	Create_Editbox(arg1,strlen("Stoptime   :")*8 + 4 * 8,20*(i-1),strlen(arg1)* 8 + 4 * 8,20,ebident +2,NULL,&current_curve->stoptime,NULL,0,12000,1);

	sprintf(arg,"Modifier start :");
	Com_WPrint(arg,0,20*i++,hdd);
	sprintf(arg1,"%f",current_curve->m_start);
	Create_Editbox(arg1,strlen(arg)*8+4*8,20*(i-1),strlen(arg1)*8+4*8,20,ebident+3,NULL,&current_curve->m_start,NULL,0,1,1);

	sprintf(arg,"Modifier stop  :");
	Com_WPrint(arg,0,20*i++,hdd);
	sprintf(arg1,"%f",current_curve->m_start);
	Create_Editbox(arg1,strlen(arg)*8+4*8,20*(i-1),strlen(arg1)*8+4*8,20,ebident+4,NULL,&current_curve->m_stop,NULL,0,1,1);

	sprintf(arg,"Fov start  :");
	Com_WPrint(arg,0,20*i++,hdd);
	sprintf(arg1,"%f",current_curve->fov_start);
	Create_Editbox(arg1,strlen(arg)*8+4*8,20*(i-1),strlen(arg1)*8+4*8,20,ebident+5,NULL,&current_curve->fov_start,NULL,0,360,1);

	sprintf(arg,"Fov stop   :");
	Com_WPrint(arg,0,20*i++,hdd);
	sprintf(arg1,"%f",current_curve->fov_stop);
	Create_Editbox(arg1,strlen(arg)*8+4*8,20*(i-1),strlen(arg1)*8+4*8,20,ebident+6,NULL,&current_curve->fov_stop,NULL,0,360,1);

	sprintf(arg,"DemoSpeed start  :");
	Com_WPrint(arg,0,20*i++,hdd);
	sprintf(arg1,"%f",current_curve->ds_start);
	Create_Editbox(arg1,strlen(arg)*8+4*8,20*(i-1),strlen(arg1)*8+4*8,20,ebident+7,NULL,&current_curve->ds_start,NULL,0,100,1);

	sprintf(arg,"DemoSpeed stop   :");
	Com_WPrint(arg,0,20*i++,hdd);
	sprintf(arg1,"%f",current_curve->ds_stop);
	Create_Editbox(arg1,strlen(arg)*8+4*8,20*(i-1),strlen(arg1)*8+4*8,20,ebident+8,NULL,&current_curve->ds_stop,NULL,0,100,1);

	sprintf(arg,"Rotation start   :");
	Com_WPrint(arg,0,20*i++,hdd);
	sprintf(arg1,"%f",current_curve->r_start);
	Create_Editbox(arg1,strlen(arg)*8+4*8,20*(i-1),strlen(arg1)*8+4*8,20,ebident+9,NULL,&current_curve->r_start,NULL,0,0,0);

	sprintf(arg,"Rotation stop   :");
	Com_WPrint(arg,0,20*i++,hdd);
	sprintf(arg1,"%f",current_curve->r_stop);
	Create_Editbox(arg1,strlen(arg)*8+4*8,20*(i-1),strlen(arg1)*8+4*8,20,ebident+10,NULL,&current_curve->r_stop,NULL,0,0,0);

	sprintf(arg,"DOF Modifier start :");
	Com_WPrint(arg,0,20*i++,hdd);
	sprintf(arg1,"%f",current_curve->dof_modifier_start);
	Create_Editbox(arg1,strlen(arg)*8+4*8,20*(i-1),strlen(arg1)*8+4*8,20,ebident+11,NULL,&current_curve->dof_modifier_start,NULL,0,0,0);

	sprintf(arg,"DOF Modifier stop  :");
	Com_WPrint(arg,0,20*i++,hdd);
	sprintf(arg1,"%f",current_curve->dof_modifier_stop);
	Create_Editbox(arg1,strlen(arg)*8+4*8,20*(i-1),strlen(arg1)*8+4*8,20,ebident+12,NULL,&current_curve->dof_modifier_stop,NULL,0,0,0);

	Create_Button("quit via console","quit",NULL,300,400,120,25,btident);
	Create_Button("quit via function",NULL,CL_Quit_f,300,425,120,25,btident+1);





}

void Stat_Window_Init(void){
	//Cmd_AddCommand("stat_window",My_Testfunction);
}


LONG Stat_Window_Main_Handle(HWND hWnd, UINT uMsg,WPARAM  wParam, LPARAM  lParam){
	LONG lret;
lret = 0;
switch (uMsg) {	
				case WM_COMMAND: 
				{
					switch(LOWORD(wParam))
					{
						default :
						{
						switch(HIWORD(wParam))
							{
								case EN_CHANGE:
									{
									char Buffer[256];
									GetWindowText((HWND)lParam, Buffer, 256);
									ChangeEditbox(Buffer,LOWORD(wParam));
									break;
									}
								case BN_CLICKED:
									{
									Button_Execute(LOWORD(wParam));
									break;
									}
								case CBN_SELCHANGE:
									{
									Combobox_Process(LOWORD(wParam),HIWORD(wParam));
									break;
									}
								default :
									break;
							}
						}
					}
					}
					break;
				case WM_KEYDOWN:
					Com_Printf("Test %i %i\n",HIWORD(wParam),LOWORD(wParam));
					switch (lParam){
						case 1835009:
							{
							Editbox_Change();
							Com_Printf("Test %i\n",LOWORD(wParam));
							}
						break;
						default :
							break;
					}
					break;
				case WM_CREATE:
					Create_SubWindow();
					break;
				case WM_PAINT:
					{
					Create_SubWindow();
					//update_subwindow = 1;
					}
					break;
				default:
					lret = DefWindowProc (hWnd, uMsg, wParam, lParam);
					break;
			}

return lret;

}

#endif
