/*
	$Id: avi.c,v 1.1 2007/02/12 04:31:57 jogi Exp $
*/

#include "common.h"
#include "quakedef.h"
#include "sys/stat.h"

 typedef struct {
	int			texnum;
	char		identifier[MAX_QPATH];
	char		*pathname;
	int			width, height;
	int			scaled_width, scaled_height;
	int			texmode;
	unsigned	crc;
	int			bpp;
} gltexture_t;

extern gltexture_t	gltextures[MAX_GLTEXTURES];

typedef struct tm_s {
	int					date[3];
	int					iglnum;
	int					glnum;
	char				name[256];
	struct tm_s	*next;
	} tm_t;

static qbool tm_frame = 0;

tm_t *tm_list = NULL;

cvar_t	jogi_interpol = {"jogi_interpol","0"};

cvar_t	jogi_3d_text_x	=	{"jogi_3d_text_x","0"};
cvar_t	jogi_3d_text_y	=	{"jogi_3d_text_y","0"};
cvar_t	jogi_3d_text_z	=	{"jogi_3d_text_z","0"};

cvar_t	jogi_3d_text_ax	=	{"jogi_3d_text_ax","0"};
cvar_t	jogi_3d_text_ay	=	{"jogi_3d_text_ay","0"};
cvar_t	jogi_3d_text_az	=	{"jogi_3d_text_az","0"};

cvar_t	jogi_3d_text_string	=	{"jogi_3d_text_strin","TEST STRING"};


__inline static void Draw_3D_CharPoly(int x, int y, int num) {
	float frow, fcol;

	frow = (num >> 4) * 0.0625;
	fcol = (num & 15) * 0.0625;

	glTexCoord2f (fcol, frow);
	glVertex2f (x, y);
	glTexCoord2f (fcol + 0.0625, frow);
	glVertex2f (x + 8, y);
	glTexCoord2f (fcol + 0.0625, frow + 0.03125);
	glVertex2f (x + 8, y + 8);
	glTexCoord2f (fcol, frow + 0.03125);
	glVertex2f (x, y + 8);

}

__inline static void Draw_3D_CharPoly_Backward(int x, int y, int num) {
	float frow, fcol;

	frow = (num >> 4) * 0.0625;
	fcol = (num & 15) * 0.0625;


	glTexCoord2f (fcol, frow + 0.03125);

	
	glVertex2f (x, y);


	glTexCoord2f (fcol + 0.0625, frow + 0.03125);

	glVertex2f (x + 8, y);

	glTexCoord2f (fcol + 0.0625, frow);


	glVertex2f (x + 8, y + 8);

	glTexCoord2f (fcol, frow);


	glVertex2f (x, y + 8);


}


void Draw_3D_String_Colored(vec3_t	location,	vec3_t	direction, char *string,int x,int y, float r, float g, float b){

	int j,k;
	int num;
	char *str;
	extern int char_texture;
	
	glPushMatrix();
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	glColor3f(r,g,b);
		GL_Bind (char_texture);
	glTranslatef(location[0],location[1],location[2]);
	glRotatef (90, 0, 0, 1);
	glRotatef (180, 0, 1, 0);
	glRotatef (180, 1, 0, 0);

	glRotatef (direction[1], 0, 0, 1);
	glRotatef (direction[0], 0, 1, 0);
	glRotatef (-direction[2], 1, 0, 0);

	str = string;																			

	//Com_Printf("%f %f %f\n",direction[0],direction[1],direction[2]);
	//Com_Printf("%f %f %f\n",location[0],location[1],location[2]);
	glEnable(GL_BLEND);
	glBegin (GL_QUADS);

	j=x,k=y;
	while (*str) {	// stop rendering when out of characters		
		if ((num = *str++) != 32)	// skip spaces
			Draw_3D_CharPoly(j, k, num);

		j += 8;															 
	}
	glEnd();


	str = string;
	glRotatef(180,1,0,0);
	glBegin(GL_QUADS);
	j=x,k= -y-8;
	while (*str) {	// stop rendering when out of characters		
		if ((num = *str++) != 32)	// skip spaces
			Draw_3D_CharPoly_Backward(j, k, num);

		j +=8;
	}

	glEnd();
	glPopMatrix();
	glTexEnvf (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

	}


void Draw_3D_String(vec3_t	location,	vec3_t	direction, char *string,int x,int y){

	int j,k;
	int num;
	char *str;
	extern int char_texture;
	
	glPushMatrix();
	
	GL_Bind (char_texture);
	glTranslatef(location[0],location[1],location[2]);
	glRotatef (90, 0, 0, 1);
	glRotatef (180, 0, 1, 0);
	glRotatef (180, 1, 0, 0);

	glRotatef (direction[1], 0, 0, 1);
	glRotatef (direction[0], 0, 1, 0);
	glRotatef (-direction[2], 1, 0, 0);

	str = string;

	//Com_Printf("%f %f %f\n",direction[0],direction[1],direction[2]);
	//Com_Printf("%f %f %f\n",location[0],location[1],location[2]);
	glEnable(GL_BLEND);
	glBegin (GL_QUADS);

	j=x,k=y;
	while (*str) {	// stop rendering when out of characters		
		if ((num = *str++) != 32)	// skip spaces
			Draw_3D_CharPoly(j, k, num);

		j += 8;															 
	}
	glEnd();


	str = string;
	glRotatef(180,1,0,0);
	glBegin(GL_QUADS);
	j=x,k= -y-8;
	while (*str) {	// stop rendering when out of characters		
		if ((num = *str++) != 32)	// skip spaces
			Draw_3D_CharPoly_Backward(j, k, num);

		j +=8;
	}

	glEnd();



	//glRotatef(180,1,0,0);

	//glBegin (GL_QUADS);

	
	//glEnd();
	glPopMatrix();
	glDisable(GL_BLEND);


	}


void Draw_3D_RectangleRGB (vec3_t	location, vec3_t	direction, int x, int y, int w, int h, float r, float g, float b, float a, float f,float t){


	if (!a)
		return;

	glPushMatrix();
	glTranslatef(location[0],location[1],location[2]);

	glRotatef (90, 0, 0, 1);
	glRotatef (180, 0, 1, 0);
	glRotatef (180, 1, 0, 0);

	glRotatef (direction[1], 0, 0, 1);
	glRotatef (direction[0], 0, 1, 0);
	glRotatef (-direction[2], 1, 0, 0);

	


	glEnable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);

	glColor4f(r,g,b,a);

	if(f)
	{
		glRectf(x, y, x + w, y + h);
	}
	else
	{
		glRectf(x, y, x + w	, y + t);		
		glRectf(x, y + t, x + t, y + h - t);
		glRectf(x + w - t, y + t, x + w, y + h - t);		
		glRectf(x, y + h, x + w, y + h - t);
	}



	glDisable(GL_BLEND);
	glEnable(GL_TEXTURE_2D);
	glPopMatrix();


	}

void Draw_3D_Pic (vec3_t	location, vec3_t	direction, int gl, float x, float y, float width, float height, float r, float g, float b, float a, float scale_x, float scale_y){


	if (!a)
		return;
	//Com_Printf("get called %i ?\n",gl);																			
	GL_Bind(gl);
	glPushMatrix();
	glEnable(GL_TEXTURE_2D);
	glTranslatef(location[0],location[1],location[2]);

	//glRotatef (180, 0, 0, 1);
	//glRotatef (180, 0, 1, 0);
	//glRotatef (180, 1, 0, 0);

	glRotatef (direction[0], 1, 0, 0);
	glRotatef (direction[1], 0, 1, 0);
	glRotatef (direction[2], 0, 0, 1);

	//glRectf(x, y,  + scale_x * width, y + scale_y * height);
	glEnable(GL_BLEND);

	
	
	glColor4f(r,g,b,a);
																																	
	glBegin(GL_QUADS);
	
	// Upper left corner.
	glTexCoord2f (0, 0);
    glVertex2f (x, y);
   
	// Upper right corner.
	glTexCoord2f (0, 1);
    //glVertex2f (x + scale_x * width, y);
		glVertex2f(width,y);
   
	// Bottom right corner.
	glTexCoord2f (1, 1);
    //glVertex2f (x + scale_x * width, y + scale_y * height);
	glVertex2f (width,height);
    
	// Bottom left corner.
	glTexCoord2f (1, 0);
    //glVertex2f (x, y + scale_y * height);
		glVertex2f (x, height);

		glEnd();

		glRotatef(180,1,0,0);
	glBegin(GL_QUADS);
	glTexCoord2f (0, 0);
    glVertex2f (x, y);
   
	// Upper right corner.
	glTexCoord2f (0, 1);
    //glVertex2f (x + scale_x * width, y);
		glVertex2f(width,y);
   
	// Bottom right corner.
	glTexCoord2f (1, 1);
    //glVertex2f (x + scale_x * width, y + scale_y * height);
	glVertex2f (width,height);
    
	// Bottom left corner.
	glTexCoord2f (1, 0);
    //glVertex2f (x, y + scale_y * height);
		glVertex2f (x, height);

	glEnd();
	glDisable(GL_BLEND);
	//glEnable(GL_TEXTURE_2D);
	glPopMatrix();


	}


void set_text(void){
		Cvar_Set(&jogi_3d_text_x,va("%f",r_refdef.vieworg[0]));
		Cvar_Set(&jogi_3d_text_y,va("%f",r_refdef.vieworg[1]));
		Cvar_Set(&jogi_3d_text_z,va("%f",r_refdef.vieworg[2]));

		Cvar_Set(&jogi_3d_text_ax,va("%f",r_refdef.viewangles[0]));
		Cvar_Set(&jogi_3d_text_ay,va("%f",r_refdef.viewangles[1]));
		Cvar_Set(&jogi_3d_text_az,va("%f",r_refdef.viewangles[2]));
	}

void tcrap_list(void);
void test_init (void){
	Cvar_Register(&jogi_interpol);
	Cvar_Register(&jogi_3d_text_x);
	Cvar_Register(&jogi_3d_text_y);
	Cvar_Register(&jogi_3d_text_z);
	Cvar_Register(&jogi_3d_text_ax);
	Cvar_Register(&jogi_3d_text_ay);
	Cvar_Register(&jogi_3d_text_az);
	Cvar_Register(&jogi_3d_text_string);
	Cmd_AddCommand("jogi_set_text",set_text);
	Cmd_AddCommand("jogi_tm_list",tcrap_list);


}
void tcrap_frame(void);
void test_frame (void){
	int i,x,rows,row,y=0,lines;
	extern console_t	con;
	extern int con_linewidth;
	char	buf[1024];
	extern char	key_lines[32][256];
	int len;
	vec3_t old,current,interpol;
	extern float scr_con_current;
	extern int	edit_line;
	extern float con_cursorspeed;
	extern int key_linepos;
	extern qbool con_redchars;
	char *text, temp[256 + 1];	//+ 1 for cursor if strlen(key_lines[edit_line]) == (MAX_CMDLINE - 1)


	tcrap_frame();

	VectorSet(old,jogi_3d_text_x.value,jogi_3d_text_y.value,jogi_3d_text_z.value);
	VectorSet(current,jogi_3d_text_ax.value,jogi_3d_text_ay.value,jogi_3d_text_az.value);

	strlcpy(temp, key_lines[edit_line], 256);
	len = strlen(temp);
	text = temp;

	memset(text + len, ' ', 256 - len);		// fill out remainder with spaces
	text[256] = 0;

	// add the cursor frame
	if ((int) (curtime * con_cursorspeed) & 1)
		text[key_linepos] = con_redchars ? (11 + 128) : 11;

	//	prestep if horizontally scrolling
	if (key_linepos >= con_linewidth)
		text += 1 + key_linepos - con_linewidth;



	//Draw_3D_String(old,current,text,0,+8);


	lines = scr_con_current;

	// changed to line things up better
	rows = (lines - 22) >> 3;		// rows of text to draw

	row = con.display;

	for (i = 0; i < rows; i++, y -= 8, row--) {
		if (row < 0)
			break;
		if (con.current - row >= con_totallines)
			break;		// past scrollback wrap point

		text = con.text + (row % con_totallines)*con_linewidth;

		// copy current line to buffer
		for(x = 0; x < con_linewidth; x++) {
			buf[x] = *text;
			text++;
		}
		buf[x] = '\0';
		//Com_Printf("y: %s buf %i\n",buf,y);
		//Draw_3D_String(old,current,buf,0,y);
	}
	
	//Draw_3D_String(old,current,"test",0,0);	
	

	return;
	if (!jogi_interpol.value)
		return;
	for (i =0;i<MAX_CLIENTS;i++)
		if (!strcmp("son",cl.players[i].name))
			break;
		else if ( i == MAX_CLIENTS -1)
			return;
	
	VectorCopy(cl.frames[(cl.parsecount & UPDATE_MASK) - 1].playerstate[i].origin,old);
	VectorCopy(cl.frames[cl.parsecount & UPDATE_MASK].playerstate[i].origin,current);
	Com_Printf("old: : %f %f %f\n",old[0],old[1],old[2]);
	Com_Printf("new: : %f %f %f\n",current[0],current[1],current[2]);
	for (x=0;x<4;x++)
		interpol[x] = (current[x] - old[x]) * 0.5 + old[x];
	//` ` `Com_Printf("new: : %f %f %f\n",interpol[0],interpol[1],interpol[2]);
	VectorCopy(interpol,cl.frames[cl.parsecount & UPDATE_MASK].playerstate[i].origin);
	/*cl.frames[cl.parsecount & UPDATE_MASK].playerstate[i].origin[0] = 0;
	cl.frames[cl.parsecount & UPDATE_MASK].playerstate[i].origin[1] = 0;
	cl.frames[cl.parsecount & UPDATE_MASK].playerstate[i].origin[2] = 0;*/

}



void tcrap_frame(void){
	int i = 0;
	int k;
	tm_t *current;
	extern int numgltextures;
	struct tm* clock;
	struct stat	attribs;
			gltexture_t	*gt;
		static double time;
		extern qbool forceTextureReload;
		byte *data;
	current = tm_list;
	
 tm_frame = 1;

	if (time + 1 < Sys_DoubleTime())
		time = Sys_DoubleTime();
	else{
		tm_frame = 0;
		return;
		}
	while (current){

		if (current->iglnum == -1){
			for (i=0;i<numgltextures;i++)
				if (gltextures[i].texnum == current->glnum)
					current->iglnum =i;
			}else{
				if (!stat(current->name,&attribs)){
					clock = gmtime(&attribs.st_mtime);
					if (current->date[0] != clock->tm_hour || current->date[1] != clock->tm_min || current->date[2] != clock->tm_sec){
						Com_Printf("%s changed, reload \n",current->name);
						current->date[0] = clock->tm_hour;
						current->date[1] = clock->tm_min ;
						current->date[2] = clock->tm_sec;
						gt = &gltextures[current->iglnum];
						//k=GL_LoadTextureImage(gt->pathname,gt->identifier,gt->scaled_width,gt->scaled_height,gt->texmode);
						gt->crc= -1;
						forceTextureReload = 1;
						//Com_Printf("%i\n",gt->texnum);
						//k= GL_LoadTextureImage(va("%s/%s",TP_MapName(),gt->identifier),NULL,0,0,gt->texmode);
						//Com_Printf("%i\n",k);
						data = GL_LoadImagePixels (va("textures/%s/%s",TP_MapName(),gt->identifier), 0, 0, gt->texmode);
						if (data == NULL)
							{
							tm_frame = 0;
							 return;
							}
						GL_LoadTexturePixels(data, gt->identifier, image_width, image_width, gt->texmode);
						//GL_LoadTexture(gt->identifier,0,0,
						Q_free(data);
						forceTextureReload = 0;
						}
				}

			}

		current=current->next;
		}
	tm_frame = 0;
	}

void tcrap_list(void){
	int i = 0;
	tm_t *current;
	extern int numgltextures;
	struct stat	attribs;
	struct tm* clock;
	current = tm_list;

	while (current){

		if (current->iglnum == -1)
			for (i=0;i<numgltextures;i++)
				if (gltextures[i].texnum == current->glnum)
					current->iglnum = gltextures[i].texnum;
		
		Com_Printf("%s %s %i:%i:%i %i %i\n",current->name,gltextures[current->iglnum].identifier,current->date[0],current->date[1],current->date[2],current->glnum,current->iglnum);

		current=current->next;
		}

	}


void tcrap(char *name){
	struct stat	attribs;
	struct tm* clock;
	extern char fs_netpath[128];
	tm_t *current;
	
	if (tm_frame)
		return;

	if (!stat(fs_netpath,&attribs)){
		clock = gmtime(&attribs.st_mtime);

		if (tm_list == NULL){
					current = Q_malloc(sizeof(tm_t));
					tm_list = current;
			}else{
					current = tm_list;
					while (current->next){
						if (!strcmp(name,current->name))
							return;
						current = current->next;
						}
					current->next = Q_malloc(sizeof(tm_t));
					current=current->next;
				}
		strcpy(current->name,fs_netpath);
		current->date[0] = clock->tm_hour;
		current->date[1] = clock->tm_min;
		current->date[2] = clock->tm_sec;
		current->glnum = texture_extension_number;
		current->next = NULL;
		current->iglnum = -1;
				


			
		}

	}

model_t *Mod_FindName (char *name);
void R_DrawAliasModel (entity_t *ent);

void HUD_3D_Setup(void){
		entity_t ent;
		model_t	*mod = NULL;
		vec3_t	testvec,forward,right,up;
		AngleVectors (r_refdef.viewangles,forward, right, up);
		glClear(GL_DEPTH_BUFFER_BIT);
 /*
	//ent = Q_malloc(sizeof(entity_t));
	memset(&ent,0,sizeof(entity_t));

	
	ent.model =  cl.model_precache[50];

	
	if (ent.model == NULL)
		return;
	currententity = &ent;
	switch (ent.model->type){
		case mod_alias:
				R_DrawAliasModel(&ent);
				break;
		case mod_alias3:
		//		R_DrawAlias3Model (ent);
				break;
		case mod_brush:
		//		R_DrawBrushModel (ent);
				break;
		case mod_sprite:
		//		R_DrawSpriteModel (ent);
				break;
		}

	 */











		VectorScale(forward,-1,forward);
		mvd_vectoangles(forward, testvec);
		glDisable(GL_DEPTH_TEST);
		glPushMatrix();
		if (testvec[1] >= 270 || testvec[1] <= 90){
					testvec[0] -= 90;
					if (testvec[0] < 0 )
						testvec[0] = -1 * testvec[0];
					else
						testvec[0] = 360 - testvec[0];
				}
		if (testvec[1] < 270 && testvec[1] > 90){
					testvec[0] -= 90;
					if (testvec[0] < 0 )
						testvec[0] = -1 * testvec[0];
					else 
						testvec[0] -= 270;
				}

		glTranslatef(r_refdef.vieworg[0],r_refdef.vieworg[1],r_refdef.vieworg[2]);
		glRotatef (testvec[1], 0, 0, 1);
		glRotatef (testvec[0] , 0, 1, 0);
		glRotatef (-testvec[2]+180, 1, 0, 0);
		//glBegin(GL_POINTS);
		//glVertex3f(jogi_3d_text_x.value,jogi_3d_text_y.value,jogi_3d_text_z.value);
		VectorSet(testvec,jogi_3d_text_x.value,jogi_3d_text_y.value,jogi_3d_text_z.value);
		VectorSet(up,jogi_3d_text_ax.value,jogi_3d_text_ay.value,jogi_3d_text_az.value);
		Draw_3D_String(testvec,up,jogi_3d_text_string.string,0,0);
	//	glEnd();

	}

void HUD_3D_End(void){
		glEnable(GL_DEPTH_TEST);
		glPopMatrix();
	}


