/*

Copyright (C) 1996-2003 A Nourai, Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the included (GNU.txt) GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	$Id: texture_stuff.c,v 1.1 2007/02/12 04:31:57 jogi Exp $
*/

#include "quakedef.h"
#include "collision.h"
#define ts_max_textures 10

typedef struct {
	int			texnum;
	char		identifier[MAX_QPATH];
	char		*pathname;
	int			width, height;
	int			scaled_width, scaled_height;
	int			texmode;
	unsigned	crc;
	int			bpp;
} gltexture_t;

typedef struct ts_textures_s {
	int	orig;
	int texnum;
	int repnum;
	int reptexnum;
	char	texname[128];
}ts_textures_t;
ts_textures_t	ts_textures[ts_max_textures];


qbool TextureS_Draw_Replace(cvar_t *current,char *string);
cvar_t ts_draw_replacement = {"ts_draw_replacement","1",0,TextureS_Draw_Replace};
cvar_t ts_highlight = {"ts_highlight","-1",0,NULL};
cvar_t ts_show_name = {"ts_show_name","0",0,NULL};

void TextureS_Show_Textures (void){
	int x;
	Com_Printf("Texturenames from the level\n");
	for (x=0;x<cl.worldmodel->numtextures;x++)
		if(Cmd_Argv(1)){
			if(strstr(cl.worldmodel->textures[x]->name,Cmd_Argv(1))){
				Com_Printf("%i %s\n",x,cl.worldmodel->textures[x]->name);
				}
			}else{
				Com_Printf("%i %s\n",x,cl.worldmodel->textures[x]->name);
			}
	Com_Printf("Texturenames from seprately loaded textures\n");
	for (x=0;x<ts_max_textures;x++)
		if(Cmd_Argv(1)){
			if(strstr(cl.worldmodel->textures[x]->name,Cmd_Argv(1))){
				if (ts_textures[x].texnum != 0)
					Com_Printf("%i %s\n",x,ts_textures[x].texname);
				}
			}else{
							Com_Printf("%i %s\n",x,ts_textures[x].texname);
			}

	Com_Printf("%i\n",cl.worldmodel->nummarksurfaces);
}

void TextureS_Replace_Textures (void){
	if (Cmd_Argc() < 3)
		return;
	if (!ts_textures[atoi(Cmd_Argv(2))].orig)
		ts_textures[atoi(Cmd_Argv(2))].orig = cl.worldmodel->textures[atoi(Cmd_Argv(1))]->gl_texturenum;
	ts_textures[atoi(Cmd_Argv(2))].reptexnum	= cl.worldmodel->textures[atoi(Cmd_Argv(1))]->gl_texturenum;
	ts_textures[atoi(Cmd_Argv(2))].repnum		= atoi(Cmd_Argv(1));
	
	//Com_Printf(" %i\n",text->
}

void Texture_Modify(void){
	int i;
	extern int numgltextures;
	extern gltexture_t	gltextures[MAX_GLTEXTURES];
	switch (atoi(Cmd_Argv(1))){
		case 0:	for (i=0;i<numgltextures;i++)//{
				//if (atoi(Cmd_Argv(2)) == gltextures[i].texnum)
					Com_Printf("%i %i %s %i %i\n",i,gltextures[i].texnum,gltextures[i].identifier,gltextures[i].scaled_height,gltextures[i].scaled_width);
				//}
				break;
		case 1: gltextures[atoi(Cmd_Argv(2))].scaled_height	=	atoi(Cmd_Argv(3));
				gltextures[atoi(Cmd_Argv(2))].scaled_width	=	atoi(Cmd_Argv(4));
				break;
	}


}

void	Textures_Replace(void){
	if (!strlen(Cmd_Argv(1))){
		Com_Printf("Please supply a texture number\n");
		return;
	}
	if (atoi(Cmd_Argv(1)) > cl.worldmodel->numtextures){
		Com_Printf("Maximum number texture number is %i\n",cl.worldmodel->numtextures);
		return;
	}
	cl.worldmodel->textures[atoi(Cmd_Argv(1))]->gl_texturenum = atoi(Cmd_Argv(2));

}

void TextureS_Load_Texture (void){
	char name[128];
	int num,x;

	snprintf (name, sizeof(name), "ts/%s.png", Cmd_Argv(1));
	num=0;
	num = GL_LoadTextureImage(name,Cmd_Argv(1),0,0,1);
	if (!num){
		Com_Printf("Something went wrong :>\n");
		return;
	}
	
	for (x=0;x<ts_max_textures;x++)
		if (ts_textures[x].texnum == 0){
			ts_textures[x].texnum = num;
			strcpy(ts_textures[x].texname,name);
			Com_Printf("Loaded texture %s as number %i\n",Cmd_Argv(1),x);
			return;
		}


}

qbool TextureS_Draw_Replace(cvar_t *current,char *string){
	int i;
	if (atoi(string) == 1)
		for (i=0;i<ts_max_textures;i++)
			if (ts_textures[i].texnum){
				cl.worldmodel->textures[ts_textures[i].repnum]->gl_texturenum = ts_textures[i].texnum;
			}

	if (atoi(string) == 0)
		for (i=0;i<ts_max_textures;i++)
			if (ts_textures[i].texnum){
				cl.worldmodel->textures[ts_textures[i].repnum]->gl_texturenum = ts_textures[i].reptexnum;
			}


	return 1;
}

void TextureS_Clear_Textures(void){
	int i;
	for (i=0;i<ts_max_textures;i++)
		ts_textures[i].texnum = 0;
}


void TextureS_Frame(void){



}


void Texture_blah(void){
	float maxfrac;
	int n,i,k;
	entity_t *ent;
	float *v;
	float tracemins[3], tracemaxs[3];
	ctrace_t trace;
	vec3_t	vec3_origin, start, end,forward,up,right,mins,maxs;
	msurface_t *s;
	msurface_t	*lf = NULL;
	float	dist,dist1,minx,miny,minz;


	if (!ts_show_name.value)
		return;
	AngleVectors (r_refdef.viewangles,forward, right, up);
	for (i=0;i<3;i++)
		end[i] = r_refdef.vieworg[i] + forward[i] * 10000;

	//MVD_TraceLine (r_refdef.vieworg, dest, impact, normal, 0, 1, &test);
	
	VectorCopy(r_refdef.vieworg,start);
	//Com_Printf("%f %f %f\n",start[0],start[1],start[2]);
	//Com_Printf("%f %f %f\n",end[0],end[1],end[2]);
	
	Collision_ClipTrace(&trace, NULL, cl.worldmodel, vec3_origin, vec3_origin, vec3_origin, vec3_origin, start, vec3_origin, vec3_origin, end);
	
	//Com_Printf("%f %f %f %f\n",trace.plane.dist,trace.plane.normal[0],trace.plane.normal[1],trace.plane.normal[2]);

	glDisable(GL_TEXTURE_2D);
	//glDisable(GL_DEPTH_TEST);
	glPointSize(10);
	glBegin(GL_POINTS);
	glVertex3f(trace.endpos[0],trace.endpos[1],trace.endpos[2]);
	glEnd();
	glFlush();
	
	//glEnable(GL_DEPTH_TEST);
	VectorCopy(trace.endpos,mins);
	VectorCopy(trace.endpos,maxs);
	//Com_Printf("%f %f %f\n",mins[0],mins[1],mins[2]);
	dist = 999999999;
	for (i=0;i < cl.worldmodel->numsurfaces;i++){
		s = &cl.worldmodel->surfaces[i];
		//for (; s; s = s->texturechain){
			/*if (BoxOnPlaneSide(mins,maxs,s->plane))
				lf = s;
				*/
			if (PlaneDist(mins,s->plane) < dist){
				 lf = s;
				 dist = PlaneDiff(mins,s->plane) ;
				}
		//}
	}

	if (lf){
		glDisable(GL_DEPTH_TEST);
		Com_Printf("Test %s\n",lf->texinfo->texture->name);
		glBegin(GL_POLYGON);
		v = lf->polys->verts[0];
		for (k = 0; k < lf->polys->numverts; k++, v += VERTEXSIZE) {
			glVertex3fv(v);
		}
		glEnd();
	
	}
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_DEPTH_TEST);
	}

void TextureS_usframe(void){
	msurface_t *s;
	float *v;
	int k;
	int i,j;


	Texture_blah();


	if (ts_highlight.value < 0 || !cl.worldmodel)
		return;
	
	j = (int)ts_highlight.value;
	if (j>cl.worldmodel->numtextures)
		j=cl.worldmodel->numtextures;
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_DEPTH_TEST);

		i=0;
		s = cl.worldmodel->surfaces->texturechain;
		for (i=0;i < cl.worldmodel->numsurfaces;i++){
			s = &cl.worldmodel->surfaces[i];
			if (s->texinfo->texture->gl_texturenum != cl.worldmodel->textures[j]->gl_texturenum)
				continue;
			for (; s; s = s->texturechain){
				i++;
				v = s->polys->verts[0];
				glPointSize(5.0);
				glColor3f(1,0,0);
				glBegin(GL_POINTS);
				for (k = 0; k < s->polys->numverts; k++, v += VERTEXSIZE){
					glVertex3f(v[0],v[1],v[2]);
				}
				glEnd();
				glColor3f(1,1,1);
				v = s->polys->verts[0];
				glBegin(GL_LINE_LOOP);
				for (k = 0; k < s->polys->numverts; k++, v += VERTEXSIZE){
					glVertex3fv(v);
				}
				v = s->polys->verts[0];
				glVertex3fv(v);
				glEnd();
				glBegin(GL_POLYGON);
				for (k = 0; k < s->polys->numverts; k++, v += VERTEXSIZE) {
					glVertex3fv(v);
				}
				glEnd();
				glFlush();
			}
		}
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_DEPTH_TEST);

	
}

void TextureS_Init(void){

	Cmd_AddCommand("ts_show_textures",TextureS_Show_Textures);
	Cmd_AddCommand("ts_load_textures",TextureS_Load_Texture);
	Cmd_AddCommand("ts_replace_textures",TextureS_Replace_Textures);
	Cmd_AddCommand("ts_clear_textures",TextureS_Clear_Textures);
	Cmd_AddCommand("ts_replace_textures_avi",Textures_Replace);
	Cmd_AddCommand("ts_modify_textures",Texture_Modify);
	Cvar_Register(&ts_draw_replacement);
	Cvar_Register(&ts_highlight);
	Cvar_Register(&ts_show_name);
}

